<?php

namespace Ionos\Performance;

if ( ! defined( 'ABSPATH' ) ) {
	die();
}

/**
 * Plugin class
 */
class Plugin {

	static function add_htaccess_snippet() {
		$path           = dirname( WP_CONTENT_DIR ) . '/.htaccess';
		$htaccess_file  = file_get_contents( $path );
		$config_array   = json_decode( file_get_contents( plugin_dir_path( __DIR__ ) . 'config/ionos-performance.json' ), true );

		if ( isset( $config_array['htaccess'] ) && @file_exists( $path ) && self::is_htaccess_modified() === false ) {

			if ( strpos( $htaccess_file, '# BEGIN WordPress' ) !== false ) {
				$htaccess_file = str_replace( '# BEGIN WordPress', $config_array['htaccess'] . PHP_EOL . '# BEGIN WordPress', $htaccess_file);
			} else {
				$htaccess_file = $config_array['htaccess'] . PHP_EOL . $htaccess_file;
			}
			file_put_contents( $path, $htaccess_file );
		}
	}

	static function is_htaccess_modified() {
		$result = false;
		$path   = dirname( WP_CONTENT_DIR ) . '/.htaccess';
		if ( @file_exists( $path ) ) {
			preg_match_all( '/# START IONOS_Performance(.|\n)*?# END IONOS_Performance/', file_get_contents( $path ), $matches, PREG_SET_ORDER, 0 );
			$result = count( $matches ) > 0;
		}

		return $result;
	}

	static function remove_htaccess_snippet() {
		$path = dirname( WP_CONTENT_DIR ) . '/.htaccess';
		if ( @file_exists( $path ) ) {
			file_put_contents( $path, preg_replace( '/# START IONOS_Performance(.|\n)*?# END IONOS_Performance\n/', '', file_get_contents( $path ) ) );
		}
	}
}
