<?php

defined( 'ABSPATH' ) || exit;

if ( ! class_exists( 'Redux' ) ) {
	return;
}

$opt_name = 'pfsizecontrol_options';

$args = array(
	'opt_name'                  => $opt_name,
	'global_variable'           => '',
	'display_name'              => esc_html__('Point Finder Size Limits','pointfindercoreelements'),
	'display_version'           => '',
	'menu_type'                 => 'submenu',
	'allow_sub_menu'            => true,
	'page_parent'               => 'pointfinder_tools',
	'menu_title'           		=> esc_html__('Size Limits Config','pointfindercoreelements'),
    'page_title'           		=> esc_html__('Size Limits Config','pointfindercoreelements'),
	'flyout_submenus'          => true,
	'admin_bar'                 => false,
	'admin_bar_priority'        => 50,
	'dev_mode'                  => false,
	'disable_google_fonts_link' => false,
	'admin_bar_icon'            => 'dashicons-portfolio',
	'customizer'                => false,
	'open_expanded'             => false,
	'disable_save_warn'         => false,
	'page_priority'             => null,
	'page_permissions'          => 'manage_options',
	'menu_icon'                 => 'dashicons-admin-tools',
	'last_tab'                  => '',
	'page_icon'                 => 'icon-themes',
	'page_slug'                 => '_pfsizelimitconf',
	'save_defaults'             => true,
	'default_show'              => false,
	'default_mark'              => '*',
	'show_import_export'        => true,
	'transient_time'            => 60 * MINUTE_IN_SECONDS,
	'output'                    => true,
	'output_tag'                => true,
	'footer_credit'             => '',
	'use_cdn'                   => true,
	'admin_theme'               => 'wp',
	'database'                  => '',
	'network_admin'             => true,
);

Redux::set_args( $opt_name, $args );


$sections = array();

/**
*Start : Image Sizes 
**/
    $sections[] = array(
        'id' => 'setupsizelimitconf_general',
        'title' => esc_html__('Image Size Settings', 'pointfindercoreelements'),
        'icon' => 'el-icon-resize-full',
        'fields' => array(
            
            /*Start:(Ajax Grid / Static Grid / Item Carousel)*/
            array(
               'id' => 'setupsizelimitconf_general_gridsize1-start',
               'type' => 'section',
               'title' => esc_html__('Item Detail Page Gallery Image Sizes', 'pointfindercoreelements'),
               'subtitle' => esc_html__('This sizes will effect Item Page Image Gallery', 'pointfindercoreelements'),
               'indent' => true 
            ),
                array(
                    'id' => 'general_crop',
                    'type' => 'button_set',
                    'title' => esc_html__('Listing Detail Gallery Images', 'pointfindercoreelements') ,
                    'options' => array(
                        '1' => esc_html__('Force Crop', 'pointfindercoreelements') ,
                        '2' => esc_html__('Use Default', 'pointfindercoreelements'),
                        '3' => esc_html__("Use Original", 'pointfindercoreelements')
                    ) , 
                    'default' => '1',
                    'desc'           => esc_html__('Please use Force Crop for same sized images. Use Default for leave free size. Use Original for resized and centered images (best for vertical images.)', 'pointfindercoreelements'),
                    
                ) ,
                array(
                    'id'             => 'setupsizelimitconf_general_gallerysize1',
                    'type'           => 'dimensions',
                    'units'          => false,
                    'units_extended' => false,
                    'title'          => esc_html__('Listing Detail Gallery Min. Size (Width/Height)', 'pointfindercoreelements'),
                    'desc'           => esc_html__('All size units (px)', 'pointfindercoreelements').' (848x566)',
                    'default'        => array(
                        'width'  => 848,
                        'height' => 566,
                    ),
                    
                ),
                array(
                    'id'             => 'setupsizelimitconf_general_gallerysize2',
                    'type'           => 'dimensions',
                    'units'          => false,
                    'units_extended' => false,
                    'title'          => esc_html__('Listing Detail Gallery Thumnails Min. Size (Width/Height)', 'pointfindercoreelements'),
                    'desc'           => esc_html__('All size units (px)', 'pointfindercoreelements').' (112x100)',
                    'default'        => array(
                        'width'  => 112,
                        'height' => 100,
                    ),
                    
                ),
            array(
               'id' => 'setupsizelimitconf_general_gridsize1-end',
               'type' => 'section',
               'indent' => false 
            ),
            /*End:(Ajax Grid / Static Grid / Item Carousel)*/   


            /*Start:(VC_Carousel, VC_Image_Carousel, VC_Client Carousel, VC_Gallery)*/
            array(
               'id' => 'setupsizelimitconf_general_gridsize2-start',
               'type' => 'section',
               'title' => esc_html__('Grid/Carousel Image Sizes', 'pointfindercoreelements'),
               'subtitle' => esc_html__('This sizes will effect Visual Composer Post Carousel, PF Image Carousel, PF Client Carousel, PF Grid Images', 'pointfindercoreelements'),
               'indent' => true 
            ),
                array(
                    'id' => 'general_crop2',
                    'type' => 'button_set',
                    'title' => esc_html__('Grid Images', 'pointfindercoreelements') ,
                    'options' => array(
                        '1' => esc_html__('Force Crop', 'pointfindercoreelements') ,
                        '2' => esc_html__('Use Default', 'pointfindercoreelements'),
                        '3' => esc_html__("Use Original", 'pointfindercoreelements')
                    ) , 
                    'default' => '1',
                    'desc'           => esc_html__('Please use Force Crop for same sized images. Use Default for leave free size. Use Original for resized and centered images (best for vertical images.)', 'pointfindercoreelements'),
                    
                ) ,
                array(
                    'id'             => 'setupsizelimitconf_general_gridsize1',
                    'type'           => 'dimensions',
                    'units'          => false,
                    'units_extended' => false,
                    'title'          => esc_html__('1 Column Min. Size (Width/Height)', 'pointfindercoreelements'),
                    'desc'           => esc_html__('All size units (px)', 'pointfindercoreelements'),
                    'default'        => array(
                        'width'  => 280,
                        'height' => 211,
                    ),
                    
                ),
                array(
                    'id'             => 'setupsizelimitconf_general_gridsize2',
                    'type'           => 'dimensions',
                    'units'          => false,
                    'units_extended' => false,
                    'title'          => esc_html__('2 Columns Min. Size (Width/Height)', 'pointfindercoreelements'),
                    'desc'           => esc_html__('All size units (px)', 'pointfindercoreelements'),
                    'default'        => array(
                        'width'  => 564,
                        'height' => 416,
                    ),
                    
                ),
                array(
                    'id'             => 'setupsizelimitconf_general_gridsize3',
                    'type'           => 'dimensions',
                    'units'          => false,
                    'units_extended' => false,
                    'title'          => esc_html__('3 Columns Min. Size (Width/Height)', 'pointfindercoreelements'),
                    'desc'           => esc_html__('All size units (px)', 'pointfindercoreelements'),
                    'default'        => array(
                        'width'  => 370,
                        'height' => 270,
                    ),
                    
                ),
                array(
                    'id'             => 'setupsizelimitconf_general_gridsize4',
                    'type'           => 'dimensions',
                    'units'          => false,
                    'units_extended' => false,
                    'title'          => esc_html__('4 Columns Min. Size (Width/Height)', 'pointfindercoreelements'),
                    'desc'           => esc_html__('All size units (px)', 'pointfindercoreelements'),
                    'default'        => array(
                        'width'  => 270,
                        'height' => 197,
                    ),
                    
                ),

            array(
               'id' => 'setupsizelimitconf_general_gridsize2-start',
               'type' => 'section',
               'indent' => false 
            ),
            /*End:(VC_Carousel, VC_Image_Carousel, VC_Client Carousel, VC_Gallery)*/

        )
    );
/**
*End : Image Sizes
**/

Redux::set_sections($opt_name,$sections);