<?php 
if (!class_exists('PointFinderAutoCMPLT')) {
	class PointFinderAutoCMPLT extends Pointfindercoreelements_AJAX
	{
	    public function __construct(){}

	    public function pf_ajax_autocomplete(){

			check_ajax_referer( 'pfget_autocomplete', 'security' );
			header('Content-Type: application/javascript; charset=UTF-8;');

		    $ftype = $searchword = $callback = '';

			if(isset($_GET['lang']) && $_GET['lang']!=''){
		        $pflang = esc_attr($_GET['lang']);
		    }

			if(class_exists('SitePress')) {
		        if (!empty($pflang)) {
		            do_action( 'wpml_switch_language', $pflang );
		        }
		    }

			//Get form type
			if(isset($_GET['ftype']) && $_GET['ftype']!=''){
				$ftype = sanitize_text_field($_GET['ftype']);
			}

			//Get search key
			if(isset($_GET['q']) && $_GET['q']!=''){
				$searchword = sanitize_text_field($_GET['q']);
			}

			//Get search key
			if(isset($_GET['callback']) && $_GET['callback']!=''){
				$callback = sanitize_text_field($_GET['callback']);
			}

			$tax_query = false;

			/* Get admin values */
			$setup3_pointposttype_pt1 = $this->PFSAIssetControl('setup3_pointposttype_pt1', '', 'pfitemfinder');
			$args = [ 'post_type' => $setup3_pointposttype_pt1, 'post_status' => 'publish','posts_per_page' => 5];

			if ($ftype == 'title') {
				$args['orderby'] = 'title';
				$args['order'] = 'ASC';
				$args['search_prod_title'] = $searchword;

			}elseif ($ftype == 'description') {
				$args['orderby'] = 'title';
				$args['order'] = 'ASC';
				$args['search_prod_desc'] = $searchword;

			}elseif ($ftype == 'title_description') {
				$args['orderby'] = 'title';
				$args['order'] = 'ASC';
				$args['search_prod_desc_title'] = $searchword;
			}elseif ($ftype == 'listingid') {
				$args['p'] = absint($searchword);
			}elseif ($ftype == 'address') {
				$pfcomptype = 'CHAR';

				if(isset($args['meta_query']) == false || isset($args['meta_query']) == NULL){
					$args['meta_query'] = [];
				}


				$args['meta_query'] = [
					'relation' => 'AND',
					[
						'key' => 'webbupointfinder_items_address',
						'value' => $searchword,
						'compare' => 'LIKE',
						'type' => $pfcomptype,
					],
				];
			}elseif (in_array($ftype, ['post_tags','pointfinderltypes','pointfinderitypes','pointfinderlocations','pointfinderfeatures'])) {
				$tax_query = true;
			}else{

				$pfcomptype = 'CHAR';

				if(isset($args['meta_query']) == false || isset($args['meta_query']) == NULL){
					$args['meta_query'] = [];
				}


				$args['meta_query'] = [
					'relation' => 'AND',
					[
						'key' => 'webbupointfinder_item_'.$ftype,
						'value' => $searchword,
						'compare' => 'LIKE',
						'type' => $pfcomptype,
					],
				];

			}

			$output_arr = [];

			if ($tax_query) {

				if ($ftype == 'post_tags') {
					$args = [
					    'orderby'           => 'name',
					    'order'             => 'ASC',
					    'hide_empty'        => false,
					    'exclude'           => [],
					    'exclude_tree'      => [],
					    'include'           => [],
					    'number'            => '',
					    'fields'            => 'all',
					    'slug'              => '',
					    'parent'            => '',
					    'hierarchical'      => true,
					    'child_of'          => 0,
					    'get'               => '',
					    'name__like'        => '',
					    'description__like' => '',
					    'pad_counts'        => false,
					    'offset'            => '',
					    'search'            => $searchword,
					];

					$terms = get_tags($args);
					foreach ($terms as $term_val) {
						$output_arr[] = urldecode($term_val->slug);
					}

				}else{
					$args = [
					    'orderby'           => 'name',
					    'order'             => 'ASC',
					    'hide_empty'        => false,
					    'exclude'           => [],
					    'exclude_tree'      => [],
					    'include'           => [],
					    'number'            => '',
					    'fields'            => 'all',
					    'slug'              => '',
					    'parent'            => '',
					    'hierarchical'      => true,
					    'child_of'          => 0,
					    'get'               => '',
					    'name__like'        => '',
					    'description__like' => '',
					    'pad_counts'        => false,
					    'offset'            => '',
					    'search'            => $searchword,
					    'cache_domain'      => 'core',
					];

					$terms = get_terms($ftype, $args);
					foreach ($terms as $term_val) {
						$output_arr[] = urldecode($term_val->name);
					}
				}
			}else{


				$the_query = new WP_Query( $args );

				if ( $the_query->have_posts() ) :

					while ( $the_query->have_posts() ) : $the_query->the_post();
						if ($ftype == 'title' || $ftype == 'description' || $ftype == 'title_description' || $ftype == 'listingid') {
							$output_arr[] = html_entity_decode(get_the_title());
						}else if($ftype == 'address'){
							$output_arr[] = html_entity_decode(get_post_meta(get_the_id(), 'webbupointfinder_items_address', true ));
						}else{
							$output_arr[] = html_entity_decode(get_post_meta(get_the_id(), 'webbupointfinder_item_'.$ftype, true ));
						}
				 	endwhile;

				 	wp_reset_postdata();

				endif;
			}

			echo $callback.'('.json_encode($output_arr).');';

			die();
		} 
	  
	}
}