<?php
if (!class_exists('PointFinderPaymentSystemc')) {

	class PointFinderPaymentSystemc extends Pointfindercoreelements_AJAX
	{
		public function __construct() {}

		public function pf_ajax_paymentsystem()
		{
			check_ajax_referer('pfcmppay', 'security');

			header('Content-Type: application/json; charset=UTF-8;');

			$item_post_id = $formtype = $msg_output = $result = $coupon = $coupontext = '';
			$update = 0;

			if (isset($_POST['formtype']) && $_POST['formtype'] != '') {
				$formtype = sanitize_text_field($_POST['formtype']);
			}

			if (isset($_POST['itemid']) && $_POST['itemid'] != '') {
				$item_post_id = absint($_POST['itemid']);
			}

			if (isset($_POST['u']) && $_POST['u'] != '') {
				$update = absint($_POST['u']);
			}

			if (isset($_POST['coupon']) && $_POST['coupon'] != '') {
				$coupon = sanitize_text_field($_POST['coupon']);
				$coupontext = $coupon;
			}

			$current_user = wp_get_current_user();
			$user_id = isset($current_user->ID) ? $current_user->ID : '';

			if (!empty($user_id) && !empty($item_post_id)) {

				$setup3_pointposttype_pt1 = PFSAIssetControl('setup3_pointposttype_pt1', '', 'pfitemfinder');

				/*Check if item user s item*/
				global $wpdb;

				$resultx = $wpdb->get_results( $wpdb->prepare(
					"SELECT ID, post_author FROM $wpdb->posts WHERE ID = %s and post_author = %s and post_type = %s",
					$item_post_id,
					$user_id,
					$setup3_pointposttype_pt1
				) );

				if ( is_array( $resultx ) && count( $resultx ) > 0 ) {
					if ( $resultx[0]->ID == $item_post_id ){

						$admin_email                     = get_option( 'admin_email' );
						$setup33_emailsettings_mainemail = PFMSIssetControl( 'setup33_emailsettings_mainemail', '', $admin_email );

						$order_id = $wpdb->get_var( $wpdb->prepare(
							"SELECT post_id FROM $wpdb->postmeta WHERE meta_key = %s and meta_value = %s",
							'pointfinder_order_itemid',
							$item_post_id
						) );
						delete_post_meta($order_id, "pointfinder_order_fremoveback");
						/* Check if sub order */
						if ( empty( $order_id ) ) {
							$order_id = $wpdb->get_var( $wpdb->prepare(
								"SELECT post_id FROM $wpdb->postmeta WHERE meta_value = %s and meta_key = %s",
								esc_attr( $_GET['token'] ),
								'pointfinder_sub_order_token'
							) );
						}

						$user_info       = get_userdata( $user_id );
						$mail_item_title = get_the_title( $item_post_id );

						$packsusr = array();

						if (have_rows('pfusr_listing_additional_package', 'option')):
							while (have_rows('pfusr_listing_additional_package', 'option')):the_row();

								$id = get_sub_field('id');

								$packsusr[$id]['status'] = get_sub_field('status');
								$packsusr[$id]['title'] = get_sub_field('title');
								$packsusr[$id]['description'] = get_sub_field('description');
								$packsusr[$id]['price'] = get_sub_field('price');
								$packsusr[$id]['background'] = get_sub_field('background');
								$packsusr[$id]['text_color'] = get_sub_field('text_color');

							endwhile;
						endif;

						$user_sp_meta = array();
						if (!empty($packsusr)):
							foreach ($packsusr as $key => $value):$val = get_post_meta($order_id, 'webbupointfinder_userboostpack_preorder_' . $key, true);
								if (!empty($val)):$user_sp_meta[$key] = absint($val);
								endif;
							endforeach;
						endif;

						$status = $txn_id = $payer_id = '';

						if (isset($_POST['status']) && $_POST['status'] != '') {
							$status = sanitize_text_field($_POST['status']);
						}

						if (isset($_POST['txn_id']) && $_POST['txn_id'] != '') {
							$txn_id = esc_attr($_POST['txn_id']);
						}

						if (isset($_POST['payer_id']) && $_POST['payer_id'] != '') {
							$payer_id = esc_attr($_POST['payer_id']);
						}

						if (!empty($coupon)){
							update_post_meta($order_id, 'pointfindercoupon',$coupon);
						}

						switch ( $formtype ) {
							case 'newdirectpayment':

								if ($status == 'COMPLETED'){

									/*Create a payment record for this process */
									$this->PF_CreatePaymentRecord(
										array(
											'user_id'       => $user_id,
											'item_post_id'  => $item_post_id,
											'order_post_id' => $order_id,
											'response'      => '',
											'token'         => $txn_id,
											'payerid'       => $payer_id,
											'processname'   => 'DoExpressCheckoutPayment',
											'status'        => $status
										)
									);

									if(!$update):
										wp_update_post( array(
											'ID'          => $item_post_id,
											'post_status' => 'publish'
										) );

										wp_update_post( array(
											'ID'          => $order_id,
											'post_status' => 'completed'
										) );
									endif;

									if($update):
										$pointfinder_order_price = esc_attr( get_post_meta( $order_id, 'pointfinder_sub_order_price', true ) );
										$pointfinder_order_listingpname = esc_attr( get_post_meta( $order_id, 'pointfinder_order_listingpname', true ) );
										$apipackage_name = $pointfinder_order_listingpname . esc_html__( '(Plan/Featured/Category Change)', 'pointfindercoreelements' );
									else:
										$pointfinder_order_price = esc_attr( get_post_meta( $order_id, 'pointfinder_order_price', true ) );
										$apipackage_name = esc_attr( get_post_meta( $order_id, 'pointfinder_order_listingpname', true ) );
									endif;


									$setup20_paypalsettings_decimals = absint($this->PFSAIssetControl( 'setup20_paypalsettings_decimals', '', '2' ));
									$total_package_price_orj = $pointfinder_order_price;
									$total_package_price = number_format( $pointfinder_order_price, $setup20_paypalsettings_decimals, '.', ',' );

									if ($update):
										$pointfinder_sub_order_changedvals = get_post_meta( $order_id, 'pointfinder_sub_order_changedvals', true );
										$this->pointfinder_additional_orders(
											array(
												'changedvals' => $pointfinder_sub_order_changedvals,
												'order_id'    => $order_id,
												'post_id'     => $item_post_id
											)
										);
									else:
										$this->pointfinder_order_fallback_operations( $order_id, $pointfinder_order_price );
									endif;

									if ( ! empty( $user_sp_meta ) ):

										foreach ($user_sp_meta as $key => $value):
											$val = get_post_meta($order_id,'webbupointfinder_userboostpack_preorder_'.$key,true);
											if(!empty($val)):
												update_post_meta($order_id, 'webbupointfinder_userboostpack_'.$key, 1);
												delete_post_meta($order_id, 'webbupointfinder_userboostpack_preorder_'.$key);
											endif;
										endforeach;

										$pricenew = 0;
										foreach ( $user_sp_meta as $spkey => $spvalue ):
											$pricenew = $pricenew + $packsusr[ $spkey ]['price'];
										endforeach;

										$pricenew = $pricenew + $pointfinder_order_price;

										$total_package_price_orj = $pricenew;
										$total_package_price = number_format( $pricenew, $setup20_paypalsettings_decimals, '.', ',' );

										$newname = '';
										foreach ( $user_sp_meta as $spkey => $spvalue ):
											if ( ! empty( $newname ) ):
												$newname .= ' - ';
											endif;
											$newname .= $packsusr[ $spkey ]['title'];
										endforeach;

										if (!$update):
											$check_featured = absint( get_post_meta( $item_post_id, 'webbupointfinder_item_featuredmarker', true ) );
										else:
											$check_featured = absint( get_post_meta( $order_id, 'pointfinder_order_featuredspupdate', true ) );
										endif;

										if ( $check_featured == 1 ) {
											$newname = 'Featured Listing + ' . $newname;
										}
										$apipackage_name = $newname;


										$this->PFCreateProcessRecord(
											array(
												'user_id'      => $user_id,
												'item_post_id' => $item_post_id,
												'processname'  => esc_html__( 'Boost option payment', 'pointfindercoreelements' ) . ' - ' . $apipackage_name .' - Coupon :'.$coupontext,
												'membership'   => 0
											)
										);

										$this->pointfinder_mailsystem_mailsender(
											array(
												'toemail'    => $setup33_emailsettings_mainemail,
												'predefined' => 'newboostplanordered',
												'data'       => array(
													'ID'           => $item_post_id,
													'title'        => $mail_item_title,
													'paymenttotal' => $total_package_price,
													'packagename'  => $apipackage_name
												),
											)
										);

									endif;

									update_post_meta($order_id, 'pointfinder_order_price',$total_package_price_orj );
									/* Create an invoice for this */
									$this->PF_CreateInvoice(
										array(
											'user_id'     => $user_id,
											'item_id'     => $item_post_id,
											'order_id'    => $order_id,
											'description' => $apipackage_name,
											'processname' => esc_html__( 'Paypal Payment', 'pointfindercoreelements' ),
											'amount'      => $total_package_price,
											'datetime'    => strtotime( "now" ),
											'packageid'   => 0,
											'status'      => 'publish'
										)
									);

									$this->pointfinder_mailsystem_mailsender(
										array(
											'toemail'    => $user_info->user_email,
											'predefined' => 'paymentcompleted',
											'data'       => array(
												'ID'           => $item_post_id,
												'title'        => $mail_item_title,
												'paymenttotal' => $this->pointfinder_reformat_pricevalue_for_frontend( $total_package_price ),
												'packagename'  => $apipackage_name
											),
										)
									);

									$this->pointfinder_mailsystem_mailsender(
										array(
											'toemail'    => $setup33_emailsettings_mainemail,
											'predefined' => 'newpaymentreceived',
											'data'       => array(
												'ID'           => $item_post_id,
												'title'        => $mail_item_title,
												'paymenttotal' => $this->pointfinder_reformat_pricevalue_for_frontend( $total_package_price ),
												'packagename'  => $apipackage_name
											),
										)
									);

									if ($update){
										delete_post_meta( $order_id, 'pointfinder_sorder_featured');
										delete_post_meta( $order_id, 'pointfinder_order_featuredspupdate');
									}

									$result = 'success';
									$msg_output .= esc_html__( 'Thanks for your payment. Now please wait until our system approve your payment and activate your item listing.', 'pointfindercoreelements' );
								}else{
									$msg_output .= esc_html__( 'Can not get express checkout informations. Payment is failed.', 'pointfindercoreelements' );
								}
								break;
							case 'newrecurringpayment':
								/*
								 * 'sid': data.subscriptionID,
		                            'status': planStatus,
		                            'payer_id': payerID,
		                            'order_id': data.orderID,
		                            'create_time': createtime,
		                            'formtype': 'newrecurringpayment',
		                            'planid': '".$featuredpackid."',
		                            'u': '".$update."'
								 * */

								$sid = '';
								if (isset($_POST['sid']) && $_POST['sid'] != '') {
									$sid = esc_attr($_POST['sid']);
								}

								/*if (isset($_POST['order_id']) && $_POST['order_id'] != '') {
									$paypal_orderid = esc_attr($_POST['order_id']);
								}

								if (isset($_POST['planid']) && $_POST['planid'] != '') {
									$planid = esc_attr($_POST['planid']);
								}*/

								if ($status == 'ACTIVE'):

									/*Create a payment record for this process */
									$this->PF_CreatePaymentRecord(
										array(
											'user_id'       => $user_id,
											'item_post_id'  => $item_post_id,
											'order_post_id' => $order_id,
											'response'      => '',
											'token'         => $txn_id,
											'payerid'       => $payer_id,
											'processname'   => 'DoExpressCheckoutPayment',
											'status'        => $status
										)
									);

									if(!$update):
										wp_update_post( array(
											'ID'          => $item_post_id,
											'post_status' => 'publish'
										) );

										wp_update_post( array(
											'ID'          => $order_id,
											'post_status' => 'completed'
										) );
									endif;

									if($update):
										$pointfinder_order_price = esc_attr( get_post_meta( $order_id, 'pointfinder_sub_order_price', true ) );
									else:
										$pointfinder_order_price = esc_attr( get_post_meta( $order_id, 'pointfinder_order_price', true ) );
									endif;


									$setup20_paypalsettings_decimals = absint($this->PFSAIssetControl( 'setup20_paypalsettings_decimals', '', '2' ));
									$total_package_price_orj = $pointfinder_order_price;

									if ($update):
										$pointfinder_sub_order_changedvals = get_post_meta( $order_id, 'pointfinder_sub_order_changedvals', true );
										$this->pointfinder_additional_orders(
											array(
												'changedvals' => $pointfinder_sub_order_changedvals,
												'order_id'    => $order_id,
												'post_id'     => $item_post_id
											)
										);
									endif;

									update_post_meta($order_id, 'pointfinder_order_price',$total_package_price_orj );

									update_post_meta( $order_id, 'pointfinder_order_frecurringid', $sid);
									//update_post_meta( $order_id, 'pointfinder_order_recurringid', $sid);
									update_post_meta( $order_id, 'pointfinder_order_recurring', 1 );
									update_post_meta( $order_id, 'pointfinder_order_frecurring', 1 );
									delete_post_meta( $order_id, 'pointfinder_sorder_recurring', 1 );
									delete_post_meta( $order_id, 'pointfinder_sorder_frecurring', 1 );
									update_post_meta( $order_id, 'pfusr_autoapprove_listing', 'zero' );

									/* Create an invoice for this */
									$this->PF_CreatePaymentRecord(
										array(
											'user_id'       => $user_id,
											'item_post_id'  => $item_post_id,
											'order_post_id' => $order_id,
											'response'      => $status,
											'token'         => $sid,
											'processname'   => 'CreateRecurringPaymentsProfile',
											'status'        => $status
										)
									);

									$setup31_userpayments_pricefeatured = absint($this->PFSAIssetControl( 'setup31_userpayments_pricefeatured', '', '5' ));
									$mail_item_title = get_the_title( $item_post_id );
									$stp31_daysfeatured = absint($this->PFSAIssetControl( 'stp31_daysfeatured', '', '3' ));
									$setup31_userpayments_pricefeatured = number_format( $setup31_userpayments_pricefeatured, $setup20_paypalsettings_decimals, '.', ',' );

									$this->pointfinder_mailsystem_mailsender(
										array(
											'toemail'    => $user_info->user_email,
											'predefined' => 'recprofilecreated',
											'data'       => array(
												'ID'           => $item_post_id,
												'title'        => $mail_item_title,
												'paymenttotal' => $this->pointfinder_reformat_pricevalue_for_frontend( $setup31_userpayments_pricefeatured ),
												'packagename'  => esc_html__( 'Featured Point', 'pointfindercoreelements' ),
												'nextpayment'  => date( "Y-m-d", strtotime( "+" . $stp31_daysfeatured . " days" ) ),
												'profileid'    => $sid
											),
										)
									);

									$this->pointfinder_mailsystem_mailsender(
										array(
											'toemail'    => $setup33_emailsettings_mainemail,
											'predefined' => 'recurringprofilecreated',
											'data'       => array(
												'ID'           => $item_post_id,
												'title'        => $mail_item_title,
												'paymenttotal' => $this->pointfinder_reformat_pricevalue_for_frontend( $setup31_userpayments_pricefeatured ),
												'packagename'  => esc_html__( 'Featured Point', 'pointfindercoreelements' ),
												'nextpayment'  => date( "Y-m-d", strtotime( "+" . $stp31_daysfeatured . " days" ) ),
												'profileid'    => $sid
											),
										)
									);

									if ($update){
										delete_post_meta( $order_id, 'pointfinder_sorder_featured');
										delete_post_meta( $order_id, 'pointfinder_order_featuredspupdate');
									}

									$result = 'success';
									$msg_output .= esc_html__( 'Thanks for your payment. Now please wait until our system approve your payment and activate your item listing.', 'pointfindercoreelements' );
								else:
									$msg_output .= esc_html__( 'Sorry: The operation could not be completed. Payment is failed.', 'pointfindercoreelements' );
								endif;
								break;
						}
					}else {
						$msg_output .= esc_html__( 'Wrong item ID (It is not your item!). Payment process is stopped.', 'pointfindercoreelements' );
					}
				}else{
					$msg_output .= esc_html__( 'Wrong item ID.', 'pointfindercoreelements' );
				}

			} else {
				$msg_output .= esc_html__('Please login again to upload/edit listing (Invalid UserID).', 'pointfindercoreelements');
			}


			echo json_encode(array('result' => $result, 'msg' => $msg_output));

			die();
		}
	}
}
