<?php 
if (!class_exists('PointFinderListReviews')) {
	class PointFinderListReviews extends Pointfindercoreelements_AJAX
	{
	    public function __construct(){}


	    public function pf_ajax_listreviews(){
			check_ajax_referer( 'pfget_listreviews', 'security' );
		    header('Content-Type: text/html; charset=UTF-8;');

		    $output_data = '';
		    $pfg_paged = 1;
		    $orderby = 'newest';

			if(isset($_REQUEST['page']) && !empty($_REQUEST['page'])){
				$pfg_paged = absint($_REQUEST['page']);
			}

		    if(isset($_REQUEST['lid']) && !empty($_REQUEST['lid'])){
			    $item_id = absint($_REQUEST['lid']);
		    }

		    if(isset($_REQUEST['orderby']) && !empty($_REQUEST['orderby'])){
			    $orderby = sanitize_text_field($_REQUEST['orderby']);
		    }

		    if(empty($item_id)):die();endif;

		    switch ($orderby){
			    case 'oldest':
				    $order = 'ASC';
				    break;
			    default:
				    $order = 'DESC';
				    break;
		    }
		    $oby = 'Date';

		    $setup11_reviewsystem_revperpage = $this->PFREVSIssetControl('setup11_reviewsystem_revperpage', '', '3');
		    $setup11_reviewsystem_flagfeature = $this->PFREVSIssetControl('setup11_reviewsystem_flagfeature', '', '1');
		    $args = array(
			    'post_type' => 'pointfinderreviews',
			    'posts_per_page' => $setup11_reviewsystem_revperpage,
			    'paged' => $pfg_paged,
			    'post_status' => 'publish',
			    'meta_key' => 'webbupointfinder_review_itemid',
			    'meta_value' => $item_id,
			    'orderby' => $oby,
			    'order' => $order
		    );
		    $the_query = new WP_Query($args);

		    /*
			*	Check Results
			*		print_r($the_query->query).PHP_EOL;
			*		print_r($the_query->request).PHP_EOL;
			*		print_r($the_query->found_posts).PHP_EOL;
			*/


		    if ($the_query->have_posts()) {

			    $output_data .= '<ul>';


			    while ($the_query->have_posts()) {
				    $the_query->the_post();
				    $post_id_rev = get_the_id();
				    $author_pf_rev = get_the_title();
				    $revmetax = esc_attr(get_post_meta($post_id_rev, 'webbupointfinder_review_flag', true));

				    $flagstatus = ($revmetax != false) ? $revmetax : '';

				    $user_photo = get_the_author_meta('user_photo');
				    if (!empty($user_photo)) {
					    $user_photo = wp_get_attachment_image($user_photo);
				    }


				    $content_of_rev = ($flagstatus != 1)? get_the_content() : esc_html__('This review flagged.', 'pointfindercoreelements');
				    $user_photo_area = (!empty($user_photo))? $user_photo:get_avatar($post_id_rev, 128);


				    $output_data .= '<li class="pf-row clearfix">';

				    $output_data .= '
                                <div class="pfreview-body clearfix">
                                    <div class="col-lg-1 col-md-3 col-sm-4">
                                        <div class="review-author-image">
                                          '.$user_photo_area.'
                                        </div>
                                    </div>
    
                                    <div class="col-lg-11 col-md-9 col-sm-8">
                                        <div class="review-details-container">
    
                                            <div class="review-author-vcard">'.$author_pf_rev .' '.esc_html__('says', 'pointfindercoreelements').' :  ';
				    if ($setup11_reviewsystem_flagfeature == 1 && ($flagstatus != 1 && $flagstatus == '')) {
					    $output_data .= '<a class="review-flag-link" data-pf-revid="'.$post_id_rev.'"><i class="fas fa-flag"></i> '.esc_html__('Flag this review', 'pointfindercoreelements').'</a>';
				    }
				    $output_data .= '<a class="pf-show-review-details"><i class="fas fa-sliders-h"></i> '.esc_html__('Details', 'pointfindercoreelements').'<div class="pf-itemrevtextdetails"><div class="pf-arrow-up"></div> '.$this->pfget_reviews_peritem($post_id_rev).'</div></a>
    
                                            </div>
                                            <div class="pfreview-meta">'.wp_sprintf(esc_html__('%1$s at %2$s', 'pointfindercoreelements'), get_the_date(), get_the_time()).'</div>
    
                                            <div class="pfreview-textarea"><p>'.$content_of_rev.'</p></div>
    
    
                                        </div>
                                    </div>
                                </div>
                                ';


				    $output_data .= '</li>';
			    }


			    $output_data .= '</ul>';

		    }

		    $output_data .= '<div class="pfstatic_paginate pfreviewspaginate" data-curpage="'.$pfg_paged.'" data-totalpg="'.$the_query->max_num_pages.'" >';

		    $output_data .= '<ul class="page-numbers">';

		    if($pfg_paged != 1){
			    $output_data .= '<li>';
			    $output_data .= '<li><a class="prev page-numbers" data-pn="prev">'.esc_html__("Prev","pointfindercoreelements").'</a></li>';
			    $output_data .= '</li>';
		    }

			for($i=1;$i<=$the_query->max_num_pages;$i++){

				$output_data .= '<li>';
				if($pfg_paged == $i) {
					$output_data .= '<span aria-current="page" class="page-numbers current">'.$i.'</span>';
				}else{
					$output_data .= '<a class="page-numbers" data-pn="'.$i.'">'.$i.'</a>';
				}
				$output_data .= '</li>';

		    }

		    if($pfg_paged < $the_query->max_num_pages){
			    $output_data .= '<li>';
			    $output_data .= '<li><a class="next page-numbers" data-pn="next">'.esc_html__("Next","pointfindercoreelements").'</a></li>';
			    $output_data .= '</li>';
		    }

		    $output_data .= '</ul>';
		    $output_data .= '</div>';

			echo $this->pointfinder_sanitize_output($output_data);
			die();
		}

	}
}