<?php
/*
*
* Visual Composer PointFinder Static Grid Shortcode
*
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

class PointFinderListingSliderShortcode extends WPBakeryShortCode {
	use PointFinderOptionFunctions,
	  PointFinderCommonFunctions,
	  PointFinderWPMLFunctions,
	  PointFinderReviewFunctions,
	  PointFinderCommonVCFunctions;

    function __construct() {
        add_action( 'vc_after_init', array( $this, 'pointfinder_single_pf_itemslider_module_mapping' ) );
        add_shortcode( 'pf_itemslider', array( $this, 'pointfinder_single_pf_itemslider_module_html' ) );
    }

    

    public function pointfinder_single_pf_itemslider_module_mapping() {

      if ( !defined( 'WPB_VC_VERSION' ) ) {
          return;
      }

      $setup3_pointposttype_pt7 = $this->PFSAIssetControl('setup3_pointposttype_pt7','','Listing Types');
        $setup3_pointposttype_pt6 = $this->PFSAIssetControl('setup3_pointposttype_pt6','','Features');
        $setup3_pointposttype_pt5 = $this->PFSAIssetControl('setup3_pointposttype_pt5','','Locations');
        $setup3_pointposttype_pt4 = $this->PFSAIssetControl('setup3_pointposttype_pt4','','Item Types');

        //Check taxonomies
        $setup3_pointposttype_pt4_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt4_check','','1'));
        $setup3_pointposttype_pt5_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt5_check','','1'));
        $setup3_pointposttype_pt6_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt6_check','','1'));

        $PFVEX_GetTaxValues1 = $this->PFVEX_GetTaxValues('pointfinderltypes','setup3_pointposttype_pt7','Listing Types');
        $PFVEX_GetTaxValues2 = $this->PFVEX_GetTaxValues('pointfinderitypes','setup3_pointposttype_pt4','Item Types');
        $PFVEX_GetTaxValues3 = $this->PFVEX_GetTaxValues('pointfinderlocations','setup3_pointposttype_pt5','Locations');
        $PFVEX_GetTaxValues4 = $this->PFVEX_GetTaxValues('pointfinderfeatures','setup3_pointposttype_pt6','Features');

      /**
		*Start : Item Slider ----------------------------------------------------------------------------------------------------
		**/
			$PFVEXFields_Item_Slider = array();
			$PFVEXFields_Item_Slider['name'] = esc_html__("PF Listing Slider", 'pointfindercoreelements');
			$PFVEXFields_Item_Slider['base'] = "pf_itemslider";
			$PFVEXFields_Item_Slider['controls'] = "full";
			$PFVEXFields_Item_Slider['icon'] = "pfaicon-doc-landscape";
			$PFVEXFields_Item_Slider['category'] = "Point Finder";
			$PFVEXFields_Item_Slider['description'] = esc_html__("Item slider", 'pointfindercoreelements');
			$PFVEXFields_Item_Slider['params'] = array();

			array_push($PFVEXFields_Item_Slider['params'],
				array(
			        "type" => "textfield",
			        "heading" => esc_html__("Item IDs", "pointfindercoreelements"),
			        "param_name" => "posts_in",
			        "description" => esc_html__('Fill this field with items ID numbers separated by commas (,), to retrieve only them. Ex: 171,172,173 (Optional)', "pointfindercoreelements")
			     ),
				array(
				  "type" => "pfa_select2",
				  "heading" => $setup3_pointposttype_pt7,
				  "param_name" => "listingtype",
				  "value" => $PFVEX_GetTaxValues1,
				  "description"=>esc_html__('Leave empty for select all.','pointfindercoreelements'),
				  "admin_label" => true
				)
			);

			if($setup3_pointposttype_pt4_check == 1){
				array_push($PFVEXFields_Item_Slider['params'],
					array(
					  "type" => "pfa_select2",
					  "heading" => $setup3_pointposttype_pt4,
					  "param_name" => "itemtype",
					  "value" => $PFVEX_GetTaxValues2,
					  "description"=>esc_html__('Leave empty for select all.','pointfindercoreelements'),
					  "admin_label" => true
					)
				);
			}

			if($setup3_pointposttype_pt5_check == 1){
				array_push($PFVEXFields_Item_Slider['params'],
					array(
					  "type" => "pfa_select2",
					  "heading" => $setup3_pointposttype_pt5,
					  "param_name" => "locationtype",
					  "value" => $PFVEX_GetTaxValues3,
					  "description"=>esc_html__('Leave empty for select all.','pointfindercoreelements'),
					  "admin_label" => true
					)
				);
			}

			if($setup3_pointposttype_pt6_check == 1){
				array_push($PFVEXFields_Item_Slider['params'],
					array(
					  "type" => "pfa_select2",
					  "heading" => $setup3_pointposttype_pt6,
					  "param_name" => "features",
					  "value" => $PFVEX_GetTaxValues4,
					  "description"=>esc_html__('Leave empty for select all.','pointfindercoreelements'),
					  "admin_label" => true
					)
				);
			}

			

	        $setup4_membersettings_paymentsystem = absint($this->PFSAIssetControl('setup4_membersettings_paymentsystem','','1'));

	        if ($setup4_membersettings_paymentsystem == 1) {
	        	$lpackposts = array();
	        	$lpackposts[esc_html__('Please select','pointfindercoreelements')] = "";
		        $lpackpostsGet = get_posts(array('post_type' => 'pflistingpacks','posts_per_page' => -1,'order_by'=>'title','order'=>'ASC'));
		        foreach ($lpackpostsGet as $lpackpostsGet_single_key => $lpackpostsGet_single_value) {
		          if (isset($lpackpostsGet_single_value->post_title)) {
		            $lpackposts[$lpackpostsGet_single_value->post_title] = $lpackpostsGet_single_value->ID;
		          }
		        }
		        

		        array_push($PFVEXFields_Item_Slider['params'], 
		        	array(
		              "type" => "dropdown",
		              "heading" => esc_html__("Listing Package", "pointfindercoreelements"),
		              "param_name" => "packages",
		              "value" => $lpackposts,
		              "description" => esc_html__("This option is enabling the Listing Package option and only works with Pay per post system.", "pointfindercoreelements"),
		          	)
		        );
	    	}

			array_push($PFVEXFields_Item_Slider['params'],
				
				array(
					"type" => "dropdown",
					"heading" => esc_html__("Order by", "pointfindercoreelements"),
					"param_name" => "orderby",
					"value" => array(esc_html__("Title", "pointfindercoreelements")=>'title',esc_html__("Date", "pointfindercoreelements")=>'date'),
					"description" => esc_html__("Please select an order by filter.", "pointfindercoreelements"),
					"edit_field_class" => 'vc_col-sm-6 vc_column'

				),
				array(
					"type" => "dropdown",
					"heading" => esc_html__("Order", "pointfindercoreelements"),
					"param_name" => "sortby",
					"value" => array(esc_html__("ASC", "pointfindercoreelements")=>'ASC',esc_html__("DESC", "pointfindercoreelements")=>'DESC'),
					"description" => esc_html__("Please select an order filter.", "pointfindercoreelements"),
					"edit_field_class" => 'vc_col-sm-6 vc_column'

				),
				array(
					"type" => "textfield",
					"heading" => esc_html__("Slides count", "pointfindercoreelements"),
					"param_name" => "count",
					"value" => "5",
					"description" => esc_html__('How many slides to show? Enter number or word "All".', "pointfindercoreelements"),
					"edit_field_class" => 'vc_col-sm-4 vc_column'
				),
				array(
					  "type" => "textfield",
					  "heading" => esc_html__("Slider speed", "pointfindercoreelements"),
					  "param_name" => "interval",
					  "value" => "5000",
					  "description" => esc_html__("Duration of animation between slides (in ms)", "pointfindercoreelements"),
					  "edit_field_class" => 'vc_col-sm-4 vc_column'
				 ),
				array(
					  "type" => 'checkbox',
					  "heading" => esc_html__("Slider autoplay", "pointfindercoreelements"),
					  "param_name" => "autoplay",
					  "description" => esc_html__("Enables autoplay mode.", "pointfindercoreelements"),
					  "value" => array(esc_html__("Yes, please", "pointfindercoreelements") => 'yes'),
					  "edit_field_class" => 'vc_col-sm-4 vc_column'
					),
				array(
					  "type" => 'checkbox',
					  "heading" => esc_html__("Only show featured items", "pointfindercoreelements"),
					  "param_name" => "featureditems",
					  "description" => esc_html__("Enables featured items and hide another items on query.", "pointfindercoreelements"),
					  "value" => array(esc_html__("Yes, please", "pointfindercoreelements") => 'yes'),
					  "edit_field_class" => 'vc_col-sm-6 vc_column'
					),
				array(
					  "type" => 'checkbox',
					  "heading" => esc_html__("Hide Description Box", "pointfindercoreelements"),
					  "param_name" => "descbox",
					  "description" => esc_html__("If want to hide description box please check.", "pointfindercoreelements"),
					  "value" => array(esc_html__("Yes, please", "pointfindercoreelements") => 'yes'),
					  "edit_field_class" => 'vc_col-sm-6 vc_column'
					)
			);
			vc_map($PFVEXFields_Item_Slider);
		/**
		*End : Item Slider ----------------------------------------------------------------------------------------------------
		**/

    }


    public function pointfinder_single_pf_itemslider_module_html( $atts ) {
	  extract( shortcode_atts( array(
	    'listingtype' => '',
		'itemtype' => '',
		'locationtype' => '',
		'sortby' => 'ASC',
		'orderby' => 'title',
		'count' => 12,
		'posts_in' => '',
		'features'=> '',
		'interval' => 5000,
		'featureditems' =>'',
		'autoplay' =>'',
		'descbox'  => '',
		'packages' => ''
	  ), $atts ) );

	    wp_enqueue_style( 'owlcarousel');
	    wp_enqueue_style( 'owlcarouseltheme');
	    wp_enqueue_script('owlcarousel');

	  	if ($packages == "ps") {
	  		$packages = "";
	  	}

		$setup3_pointposttype_pt4_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt4_check','','1'));
		$setup3_pointposttype_pt5_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt5_check','','1'));
		$setup3_pointposttype_pt6_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt6_check','','1'));

		$gridrandno_orj = PF_generate_random_string_ig();
		$gridrandno = 'pf_'.$gridrandno_orj;

		$listingtype_x = $this->PFEX_extract_type_ig($listingtype);
		$itemtype_x = ($setup3_pointposttype_pt4_check == 1) ? $this->PFEX_extract_type_ig($itemtype) : '' ;
		$locationtype_x = ($setup3_pointposttype_pt5_check == 1) ? $this->PFEX_extract_type_ig($locationtype) : '' ;
		$features_x = ($setup3_pointposttype_pt6_check == 1) ? $this->PFEX_extract_type_ig($features) : '' ;


			/* Get admin values */
			$setup3_pointposttype_pt1 = $this->PFSAIssetControl('setup3_pointposttype_pt1','','pfitemfinder');


			//Container & show check
			$pfcontainerdiv = 'pflistgridview'.$gridrandno_orj.'';
			$pfcontainershow = 'pflistgridviewshow'.$gridrandno_orj.'';


			//Defaults
			$pfgetdata = array();
			$pfgetdata['sortby'] = $sortby;
			$pfgetdata['orderby'] = $orderby;
			$pfgetdata['count'] = $count;
			$pfgetdata['posts_in'] = $posts_in;
			$pfgetdata['interval'] = $interval;
			$pfgetdata['listingtype'] = $listingtype_x;
			$pfgetdata['itemtype'] = $itemtype_x;
			$pfgetdata['locationtype'] = $locationtype_x;
			$pfgetdata['features'] = $features_x;
			$pfgetdata['featureditems'] = $featureditems;
			$pfgetdata['packages'] = $packages;

			if($pfgetdata['count'] == 'All' || $pfgetdata['count'] == 'all' || $pfgetdata['count'] == 'ALL'){$pfgetdata['count'] = -1;}

			$args = array( 'post_type' => $setup3_pointposttype_pt1, 'post_status' => 'publish');
			if($pfgetdata['posts_in']!=''){
				$args['post__in'] = pfstring2BasicArray($pfgetdata['posts_in']);

			}

			if (!empty($pfgetdata['packages'])) {
				$args['listingpackagefilter'] = $pfgetdata['packages'];
			}

			$setup3_pointposttype_pt4_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt4_check','','1'));
			$setup3_pointposttype_pt5_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt5_check','','1'));
			$setup3_pointposttype_pt6_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt6_check','','1'));



			if(is_array($pfgetdata)){

				$args['tax_query'] = array();

				// listing type
				if($pfgetdata['listingtype'] != ''){
					$pfvalue_arr_lt = PFGetArrayValues_ld($pfgetdata['listingtype']);

					$fieldtaxname_lt = 'pointfinderltypes';

					if(count($args['tax_query']) > 0){
						$args['tax_query'][(count($args['tax_query'])-1)]=
						array(
								'taxonomy' => $fieldtaxname_lt,
								'field' => 'id',
								'terms' => $pfvalue_arr_lt,
								'operator' => 'IN'
						);
					}else{
						$args['tax_query']=
						array(
							'relation' => 'AND',
							array(
								'taxonomy' => $fieldtaxname_lt,
								'field' => 'id',
								'terms' => $pfvalue_arr_lt,
								'operator' => 'IN'
							)
						);
					}
				}

				if($setup3_pointposttype_pt4_check == 1){
					// location type
					if($pfgetdata['locationtype'] != ''){
						$pfvalue_arr_loc = PFGetArrayValues_ld($pfgetdata['locationtype']);

						$fieldtaxname_loc = 'pointfinderlocations';

						if(count($args['tax_query']) > 0){
							$args['tax_query'][(count($args['tax_query'])-1)]=
							array(
									'taxonomy' => $fieldtaxname_loc,
									'field' => 'id',
									'terms' => $pfvalue_arr_loc,
									'operator' => 'IN'
							);
						}else{
							$args['tax_query']=
							array(
								'relation' => 'AND',
								array(
									'taxonomy' => $fieldtaxname_loc,
									'field' => 'id',
									'terms' => $pfvalue_arr_loc,
									'operator' => 'IN'
								)
							);
						}
					}
				}

				if($setup3_pointposttype_pt5_check == 1){
					// item type
					if($pfgetdata['itemtype'] != ''){
					$pfvalue_arr_it = PFGetArrayValues_ld($pfgetdata['itemtype']);

					$fieldtaxname_it = 'pointfinderitypes';

					if(count($args['tax_query']) > 0){
						$args['tax_query'][(count($args['tax_query'])-1)]=
						array(
								'taxonomy' => $fieldtaxname_it,
								'field' => 'id',
								'terms' => $pfvalue_arr_it,
								'operator' => 'IN'
						);
					}else{
						$args['tax_query']=
						array(
							'relation' => 'AND',
							array(
								'taxonomy' => $fieldtaxname_it,
								'field' => 'id',
								'terms' => $pfvalue_arr_it,
								'operator' => 'IN'
							)
						);
					}
					}
				}

				if($setup3_pointposttype_pt6_check == 1){
					// features type
					if($pfgetdata['features'] != ''){
					$pfvalue_arr_fe = PFGetArrayValues_ld($pfgetdata['features']);

					$fieldtaxname_fe = 'pointfinderfeatures';

					if(count($args['tax_query']) > 0){
						$args['tax_query'][(count($args['tax_query'])-1)]=
						array(
								'taxonomy' => $fieldtaxname_fe,
								'field' => 'id',
								'terms' => $pfvalue_arr_fe,
								'operator' => 'IN'
						);
					}else{
						$args['tax_query']=
						array(
							'relation' => 'AND',
							array(
								'taxonomy' => $fieldtaxname_fe,
								'field' => 'id',
								'terms' => $pfvalue_arr_fe,
								'operator' => 'IN'
							)
						);
					}
					}
				}

				//Changed values by user
				$args['orderby'] = $pfgetdata['orderby'];
				$args['order'] = $pfgetdata['sortby'];
				$args['posts_per_page'] = $pfgetdata['count'];

				//Featured items filter
				if($pfgetdata['featureditems'] == 'yes'){

					$args['meta_query'] = array();

					if(count($args['meta_query']) > 0){
						$args['meta_query'][(count($args['meta_query'])-1)] = array(
							'key' => 'webbupointfinder_item_featuredmarker',
							'value' => 1,
							'compare' => '=',
							'type' => 'NUMERIC'
							);

					}else{
							$args['meta_query'] = array(
								'relation' => 'AND',
								array(
								'key' => 'webbupointfinder_item_featuredmarker',
								'value' => 1,
								'compare' => '=',
								'type' => 'NUMERIC'
							)
						);

					}
				}

			}



			//Create html codes
			$wpflistdata = "<div class='pfitemslider".$gridrandno_orj."is-container'>";
			$wpflistdata_output = '<ul id="'.$gridrandno_orj.'" class="pf-item-slider owl-carousel owl-theme">';


			$setup22_searchresults_hide_lt  = $this->PFSAIssetControl('setup22_searchresults_hide_lt','','0');
	        $st8_npsys = absint($this->PFSAIssetControl('st8_npsys','','0'));

		    $fusedfltype = absint($this->PFSAIssetControl('fusedfltype','','0'));
	        $listing_pstyle_meta = '';
		    if ($st8_npsys == 1) {
			    $listing_pstyle_meta = get_option('pointfinderltypes_style_vars');
		    }

		    $linkpermission1 = absint($this->PFSAIssetControl('st22srlinklt','','1'));
		    $st22srstxtlt1 = absint($this->PFSAIssetControl('st22srstxtlt','','1'));
		    $tooltip1 = absint($this->PFSAIssetControl('st22srstxttt','','0'));
		    $defaulticonname1 = $this->PFSAIssetControl('st22ltypebti','','fab fa-slack-hash');
		    $iconpermission1 = absint($this->PFSAIssetControl('st22ltypebts','','1'));
		    $charlimit1 = absint($this->PFSAIssetControl('st22ltypebtcl','','100'));

		    $st22ltypebtibg = $this->PFSAIssetControl('st22ltypebtibg','','#efefef');
		    $st22ltypebtiic = $this->PFSAIssetControl('st22ltypebtiic','','#494949');



			$loop = new WP_Query( $args );
				
				if($loop->post_count > 0){

					$post_ids = wp_list_pluck($loop->posts,'ID');
					$post_listingtypes = wp_get_object_terms($post_ids, 'pointfinderltypes', array("fields" => "all_with_object_id"));

					while ( $loop->have_posts() ) : $loop->the_post();

					$post_id = get_the_id();


							$ItemDetailArr = array();
							if (class_exists('SitePress')) {
								$pflang = $this->PF_current_language();
								if ($pflang) {
									$pfitemid = $this->PFLangCategoryID_ld($post_id,$pflang,$setup3_pointposttype_pt1);
								}else{
									$pfitemid = $post_id;
								}
							}else{
								$pfitemid = $post_id;
							}
							


							$featured_image = '';
							$featured_image = wp_get_attachment_image_src( get_post_thumbnail_id( $pfitemid ), 'full' );
							$ItemDetailArr['featured_image_org'] = $featured_image[0];
							$ItemDetailArr['featured_image'] = get_post_meta($pfitemid,'webbupointfinder_item_sliderimage',true);




							if(is_array($ItemDetailArr['featured_image'])){
								if(count($ItemDetailArr['featured_image'])>0 && !empty($ItemDetailArr['featured_image']['url'])){
									$ItemDetailArr['featured_image'] = $ItemDetailArr['featured_image']['url'];
								}else{
									$ItemDetailArr['featured_image'] = $ItemDetailArr['featured_image_org'];
								}
							}else{
								$ItemDetailArr['featured_image'] = $ItemDetailArr['featured_image_org'];
							}
							//Title
							$ItemDetailArr['if_title'] = get_the_title($pfitemid);
							//Exceprty
							$ItemDetailArr['if_excerpt'] = get_the_excerpt();
							//Permalink
							$ItemDetailArr['if_link'] = get_permalink($pfitemid);
							//Address
							$ItemDetailArr['if_address'] = esc_html(get_post_meta( $pfitemid, 'webbupointfinder_items_address', true ));


							$post_listing_typeval = '';
							foreach ($post_listingtypes as $post_listingtype) {
								if ($pfitemid == $post_listingtype->object_id) {
									$post_listing_typeval = $post_listingtype->term_id;
								}
							}

							$ltypeargs = array(
								'id' => $pfitemid,
								'taxonomy' => 'pointfinderltypes',
								'st8_npsys' => $st8_npsys,
								'listing_pstyle_meta' => $listing_pstyle_meta,
								'fusedfltype' => $fusedfltype,
								'postterms' => $post_listingtype,
								'linkpermission' => $linkpermission1,
								'st22srstxtlt' => $st22srstxtlt1,
								'tooltip' => $tooltip1,
								'defaulticonname' => $defaulticonname1,
								'iconpermission' => $iconpermission1,
								'charlimit' => $charlimit1,
								'st22ltypebtibg' => $st22ltypebtibg,
								'st22ltypebtiic' => $st22ltypebtiic
							);

							$output_data = $this->PFIF_DetailText_ld($pfitemid,$setup22_searchresults_hide_lt,$post_listing_typeval,$ltypeargs);

							if (is_array($output_data)) {
								if (!empty($output_data['priceval'])) {
									$output_data_priceval = $output_data['priceval'];
								} else {
									$output_data_priceval = '';
								}
							} else {
								$output_data_priceval = '';
							}


							$wpflistdata_output .= '<li class="pf-item-slider-items">
							<img src="'.$ItemDetailArr['featured_image'].'" alt="" data-no-lazy="1">';
							if($descbox != 'yes'){
							$wpflistdata_output .='
							<div class="pf-item-slider-description-container">
							<div class="pf-item-slider-description">
								<div class="pf-item-slider-title"><a href="'.$ItemDetailArr['if_link'].'">'.$ItemDetailArr['if_title'].'</a></div>
								<div class="pf-item-slider-address"><a href="'.$ItemDetailArr['if_link'].'">'.$ItemDetailArr['if_address'].'</a></div>
								<div class="pf-item-slider-excerpt"><p>'.wp_trim_words( $ItemDetailArr['if_excerpt'], 23, ' ...' ).'</p></div>
							</div>
							<div class="pf-item-slider-ex-container">';
							if(!empty($output_data_priceval)){
								$wpflistdata_output .='<div class="pf-item-slider-price clearfix">'.$output_data_priceval.'</div>';
							}
							$wpflistdata_output .='<div class="pf-item-slider-golink clearfix"><a href="'.get_the_permalink().'">'.esc_html__('Details','pointfindercoreelements').'</a></div>';


							$wpflistdata_output .='
							</div>';
							}
							$wpflistdata_output .='
							</li>';


					endwhile;
					wp_reset_postdata();
				}
				$wpflistdata_output .= '</ul>';

	            $wpflistdata .= $wpflistdata_output;
				$wpflistdata .= "</div> ";

				$content_script =
				'(function($) {
				"use strict"
					$(function() {';
						if($descbox !== 'yes'){
						$content_script .='
						$(window).on("load resize orientationchange", function(){
							if($("#'.$gridrandno_orj.'").width() < 640){

								$("#'.$gridrandno_orj.'").addClass("pfmobile");
							}else{

								$("#'.$gridrandno_orj.'").removeClass("pfmobile");
							}
						});
						';

						}
							$content_script .='
							$("#'.$gridrandno_orj.'").owlCarousel({
							items : 1,
							nav : true,
							dots : false,';
							if($autoplay == 'yes'){ $content_script .=  'autoplay : true,autoplayHoverPause : true,';}else{$content_script .=  'autoplay : false,';}
							$content_script .= '
							autoplayTimeout:'.$interval.',
							margin: 0,
							autoHeight : false,
							responsiveClass:true,
							loop:true,
							rtl:(pointfinderlcsc.rtl == "true")?true:false,
							lazyLoad:true,
							navText:["<i class=\"fas fa-chevron-left\"></i>","<i class=\"fas fa-chevron-right\"></i>"],
						});
				});

				})(jQuery);';
				wp_add_inline_script('pftheme-customjs',$content_script,'after');
		return $wpflistdata;
	}

}
new PointFinderListingSliderShortcode();

if ( class_exists( 'WPBakeryShortCode' ) ) {
    class WPBakeryShortCode_pointfinder_single_pf_itemslider extends WPBakeryShortCode {
    }
}