<?php
namespace Elementor;

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class PF_Control_Geofilter extends Base_Data_Control {

	const GEOFILTERFIELD = 'geofilterfield';

	public function get_type() {
		return self::GEOFILTERFIELD;
	}

	protected function get_default_settings() {
		return [];
	}


	public function enqueue() {
		wp_enqueue_script( 'pfgeofilterscripts', PFCOREELEMENTSURL . 'includes/elementor/fields/js/geofilter.js', [ 'jquery','theme-google-api' ], '1.0.0' );
        $maplanguage = PFSAIssetControl('setup5_mapsettings_maplanguage','','en');
        $we_special_key_google = PFSAIssetControl('setup5_map_key');
        wp_enqueue_script('theme-google-api', "https://maps.googleapis.com/maps/api/js?key=$we_special_key_google&libraries=places&language=$maplanguage");
        $setup5_typs = PFSAIssetControl('setup5_typs','','geocode');
        $wemap_country = PFSAIssetControl('wemap_country');
        $googlelvl1 = PFSAIssetControl('googlelvl1','','1000');
        $googlelvl2 = PFSAIssetControl('googlelvl2','','500');
        $googlelvl3 = PFSAIssetControl('googlelvl3','','100');
        wp_localize_script('theme-google-api', 'thgoogleapiconst',array(
            'setup5_typs'  =>  $setup5_typs,
            'wemap_country'  =>  $wemap_country,
            'googlelvl1'  =>  $googlelvl1,
            'googlelvl2'  =>  $googlelvl2,
            'googlelvl3'  =>  $googlelvl3,
        ));
	}


	public function content_template() {

		?>
		<div class="elementor-control-field geofilterfield">
			<# if ( data.label ) {#>
				<label for="geofilterselfield" class="elementor-control-title">{{{ data.label }}}</label>
			<# } #>
			<div class="elementor-control-input-wrapper">
                <input name="geofilterselfield" id="geofilterselfield" class="elementor-control-tag-area" type="text" value="{{ data.controlValue }}" data-setting="geofilterselfield" >

			</div>
		</div>
		<# if ( data.description ) { #>
			<div class="elementor-control-field-description">{{{ data.description }}}</div>
		<# } #>
		<?php
	}
}