<?php
/*
*
* Visual Composer PointFinder Static Grid Shortcode
*
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

class PointFinderListingCarouselShortcode {
	use PointFinderOptionFunctions,
	  PointFinderCommonFunctions,
	  PointFinderWPMLFunctions,
	  PointFinderReviewFunctions,
	  PointFinderCommonVCFunctions,
	  PointFinderGridSpecificFunctions;

    function __construct() {

        add_shortcode( 'pf_pfitemcarousel', array( $this, 'pointfinder_single_pf_pfitemcarousel_module_html' ) );
    }

    public function pointfinder_single_pf_pfitemcarousel_module_html( $atts ) {

      $output = $title =  $onclick = $custom_links = $img_size = $custom_links_target = $images = '';
		$autoplay = $autocrop = $customsize = $hide_pagination_control =  $speed = $zeropadding ='';
		extract(shortcode_atts(array(
		    'autoplay' => '',
		    'hide_pagination_control' => '',
		    'hide_prev_next_buttons' => '',
		    'speed' => '5000',
		    'zeropadding' => '',
		    'listingtype' => '',
			'itemtype' => '',
			'conditions' => '',
			'locationtype' => '',
			'posts_in' => '',
			'sortby' => 'ASC',
			'orderby' => 'title',
			'cols' => 4,
			'features'=>array(),
			'itemboxbg' => '',
			'featureditems'=>'',
			'featureditemshide' => '',
			'itemlimit' => 20,
			'related' => 0,
			'pfrandomize' => '',
			'packages' => ''
		), $atts));

	    wp_enqueue_style( 'owlcarousel');
	    wp_enqueue_style( 'owlcarouseltheme');
	    wp_enqueue_script('owlcarousel');

		$gal_images = '';
		$link_start = '';
		$link_end = '';
		$el_start = '';
		$el_end = '';
		$slides_wrap_start = '';
		$slides_wrap_end = '';
		$pretty_rand = $onclick == 'link_image' ? rand() : '';


		$general_crop2 = $this->PFSizeSIssetControl('general_crop2','',1);

		$general_retinasupport = absint($this->PFSAIssetControl('general_retinasupport','','0'));
		
		$myrandno = rand(1, 2147483647);
		$myrandno = md5($myrandno);
		$carousel_id = 'vc-images-carousel-'.$myrandno;

		$setup3_pointposttype_pt4_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt4_check','','1'));
		$setup3_pointposttype_pt5_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt5_check','','1'));
		$setup3_pointposttype_pt6_check = absint($this->PFSAIssetControl('setup3_pointposttype_pt6_check','','1'));
		$setup3_pt14_check = absint($this->PFSAIssetControl('setup3_pt14_check','',0));
		$st8_imagewh = absint($this->PFASSIssetControl('st8_imagewh','',0));

		$gridrandno_orj = PF_generate_random_string_ig();
		$gridrandno = 'pf_'.$gridrandno_orj;

		$listingtype_x = $this->PFEX_extract_type_ig($listingtype);
		$itemtype_x = ($setup3_pointposttype_pt4_check == 1) ? $this->PFEX_extract_type_ig($itemtype) : '' ;
		$conditions_x = ($setup3_pt14_check == 1) ? $this->PFEX_extract_type_ig($conditions) : '' ;
		$locationtype_x = ($setup3_pointposttype_pt5_check == 1) ? $this->PFEX_extract_type_ig($locationtype) : '' ;
		$features_x = ($setup3_pointposttype_pt6_check == 1) ? $this->PFEX_extract_type_ig($features) : '' ;

		$wpflistdata = "<div class='pflistgridview".$gridrandno_orj."-container pflistgridviewgr-container'>";

		/* Get admin values */
		$setup3_pointposttype_pt1 = $this->PFSAIssetControl('setup3_pointposttype_pt1','','pfitemfinder');


		//Container & show check
		$pfcontainerdiv = 'pflistgridview'.$gridrandno_orj.'';
		$pfcontainershow = 'pflistgridviewshow'.$gridrandno_orj.'';


		//Defaults
		$pfgrid = '';
		$pfitemboxbg = '';		

		$pfgetdata = array();
		$pfgetdata['sortby'] = $sortby;
		$pfgetdata['orderby'] = $orderby;
		$pfgetdata['posts_in'] = $posts_in;

		$pfgetdata['cols'] = $cols;
		$pfgetdata['itemboxbg'] = $itemboxbg;
		$pfgetdata['listingtype'] = $listingtype_x;
		$pfgetdata['itemtype'] = $itemtype_x;
		$pfgetdata['conditions'] = $conditions_x;
		$pfgetdata['locationtype'] = $locationtype_x;
		$pfgetdata['features'] = $features_x;	
		$pfgetdata['featureditems'] = $featureditems;
		$pfgetdata['featureditemshide'] = $featureditemshide;
		$pfgetdata['packages'] = $packages;


		if($pfgetdata['cols'] != ''){$pfgrid = 'grid'.$pfgetdata['cols'];}


		$args = array( 'post_type' => $setup3_pointposttype_pt1, 'post_status' => 'publish');
		$args['posts_per_page'] = $itemlimit;

		if($pfgetdata['posts_in']!=''){
			$args['post__in'] = pfstring2BasicArray($pfgetdata['posts_in']);
		}

		if (!empty($pfgetdata['packages'])) {
			$args['listingpackagefilter'] = $pfgetdata['packages'];
		}

		if(isset($args['meta_query']) == false || isset($args['meta_query']) == NULL){
			$args['meta_query'] = array();
		}	

		if(isset($args['tax_query']) == false || isset($args['tax_query']) == NULL){
			$args['tax_query'] = array();
		}


		if ($related == 1) {
			$the_current_post_id = get_the_id();

			if(!empty($the_current_post_id)){
				$args['post__not_in'] = array($the_current_post_id);
			}

			$re_li_4 = absint($this->PFSAIssetControl('re_li_4','','0'));

			if ($re_li_4 == 1) {
				$agent_id = get_post_meta($the_current_post_id, "webbupointfinder_item_agents",1);

				//Agent Filter for Related Listings
				if(!empty($agent_id)){
					$args['meta_query'][] = array(
						'key' => 'webbupointfinder_item_agents',
						'value' => $agent_id,
						'compare' => '=',
						'type' => 'NUMERIC'
					);
				}
			}


			$re_li_3 = absint($this->PFSAIssetControl('re_li_3','','1'));
			$re_li_6 = absint($this->PFSAIssetControl('re_li_6','','0'));

			if (!empty($re_li_6) && $re_li_3 == 3) {

				$currentpostvalue = get_post_meta( $the_current_post_id, 'webbupointfinder_item_'.$re_li_6, true );

				$args['meta_query'][] = array(
					'key' => 'webbupointfinder_item_'.$re_li_6,
					'value' => $currentpostvalue,
					'compare' => 'IN',
					'type' => (is_numeric($currentpostvalue))?'NUMERIC':'CHAR'
				);

			}
		}
		

		$review_system_statuscheck = absint($this->PFREVSIssetControl('setup11_reviewsystem_check','','0'));

		if(is_array($pfgetdata)){

			// listing type
			if($pfgetdata['listingtype'] != ''){
				$pfvalue_arr_lt = PFGetArrayValues_ld($pfgetdata['listingtype']);
				$fieldtaxname_lt = 'pointfinderltypes';
				$args['tax_query'][]=array(
					'taxonomy' => $fieldtaxname_lt,
					'field' => 'id',
					'terms' => $pfvalue_arr_lt,
					'operator' => 'IN'
				);
			}


			if($setup3_pointposttype_pt5_check == 1){
				// location type
				if(!empty($pfgetdata['locationtype'])){
					$pfvalue_arr_loc = PFGetArrayValues_ld($pfgetdata['locationtype']);
					$fieldtaxname_loc = 'pointfinderlocations';
					$args['tax_query'][]=array(
						'taxonomy' => $fieldtaxname_loc,
						'field' => 'id',
						'terms' => $pfvalue_arr_loc,
						'operator' => 'IN'
					);
				}
			}

			if($setup3_pointposttype_pt4_check == 1){
				// item type
				if($pfgetdata['itemtype'] != ''){
					$pfvalue_arr_it = PFGetArrayValues_ld($pfgetdata['itemtype']);
					$fieldtaxname_it = 'pointfinderitypes';
					$args['tax_query'][]=array(
						'taxonomy' => $fieldtaxname_it,
						'field' => 'id',
						'terms' => $pfvalue_arr_it,
						'operator' => 'IN'
					);
				}
			}

			if($setup3_pointposttype_pt6_check == 1){
				// features type
				if($pfgetdata['features'] != ''){
					$pfvalue_arr_fe = PFGetArrayValues_ld($pfgetdata['features']);
					$fieldtaxname_fe = 'pointfinderfeatures';
					$args['tax_query'][]=array(
						'taxonomy' => $fieldtaxname_fe,
						'field' => 'id',
						'terms' => $pfvalue_arr_fe,
						'operator' => 'IN'
					);
				}
			}

			/* Condition */
			if($setup3_pt14_check == 1){
				if($pfgetdata['conditions'] != ''){
					$pfvalue_arr_it = PFGetArrayValues_ld($pfgetdata['conditions']);
					$fieldtaxname_it = 'pointfinderconditions';
					$args['tax_query'][] = array(
						'taxonomy' => $fieldtaxname_it,
						'field' => 'id',
						'terms' => $pfvalue_arr_it,
						'operator' => 'IN'
					);
				}
			}


			if ($zeropadding !== "yes") {
				$itemspacebetween = 17;
				$pfitemboxbg = ' style="background-color:'.$pfgetdata['itemboxbg'].';"';
			}else{
				$itemspacebetween = 0;
				$pfitemboxbg = ' style="background-color:'.$pfgetdata['itemboxbg'].'; margin:0!important"';
			}

			
			$meta_key_featured = 'webbupointfinder_item_featuredmarker';
			

			if($pfgetdata['orderby'] == 'date' || $pfgetdata['orderby'] == 'title'){
				$args['orderby'] = array('meta_value_num' => 'DESC' , $pfgetdata['orderby'] => $pfgetdata['sortby']);
				if ($pfrandomize == 'yes') {
					unset($args['orderby'][$pfgetdata['orderby']]);
					$args['orderby']['rand']='';
				}
				$args['meta_key'] = $meta_key_featured;
			}

			

			//Featured items filter
			if($pfgetdata['featureditems'] == 'yes'){
				if(isset($args['meta_key'])){unset($args['meta_key']);}
				if(isset($args['orderby']['meta_value_num'])){unset($args['orderby']['meta_value_num']);}
				$args['meta_query'][] = array( 
					'key' => 'webbupointfinder_item_featuredmarker',
					'value' => 1,
					'compare' => '=',
					'type' => 'NUMERIC'
				);
			}

			//Featured items filter
			if($pfgetdata['featureditemshide'] == 'yes'){
				if(isset($args['meta_key'])){unset($args['meta_key']);}
				if(isset($args['orderby']['meta_value_num'])){unset($args['orderby']['meta_value_num']);}
				$args['orderby'] = array($pfgetdata['orderby'] => $pfgetdata['sortby']);
				if ($pfrandomize == 'yes') {
					if(isset($args['orderby'][$pfgetdata['orderby']])){unset($args['orderby'][$pfgetdata['orderby']]);}
					$args['orderby']['rand']='';
				}
				$args['meta_query'][] = array(
					'key' => 'webbupointfinder_item_featuredmarker',
					'value' => 0,
					'compare' => '=',
					'type' => 'NUMERIC'
				);
			}	
		}


		$setupsizelimitconf_general_gridsize1_width = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize1','width',280);
		$setupsizelimitconf_general_gridsize1_height = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize1','height',211);
		$setupsizelimitconf_general_gridsize2_height = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize2','height',416);
        $setupsizelimitconf_general_gridsize2_width = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize2','width',370);
        $setupsizelimitconf_general_gridsize3_height = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize3','height',270);
        $setupsizelimitconf_general_gridsize3_width = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize3','width',360);
        $setupsizelimitconf_general_gridsize4_width = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize4','width',270);
        $setupsizelimitconf_general_gridsize4_height = $this->PFSizeSIssetControl('setupsizelimitconf_general_gridsize4','height',197);

		switch($pfgrid){

			case 'grid1':
				$pf_grid_size = 1;
				$pfgrid_output = 'pf1col';
				$pfgridcol_output = '';
				$featured_image_width = $setupsizelimitconf_general_gridsize1_width;
                $featured_image_height = $setupsizelimitconf_general_gridsize1_height;
				break;
			case 'grid2':
				$pf_grid_size = 2;
				$pfgrid_output = 'pf2col';
				$pfgridcol_output = '';
				$featured_image_width = $setupsizelimitconf_general_gridsize2_width;
                $featured_image_height = $setupsizelimitconf_general_gridsize2_height;
				break;
			case 'grid3':
				$pf_grid_size = 3;
				$pfgrid_output = 'pf3col';
				$pfgridcol_output = '';
				$featured_image_width = $setupsizelimitconf_general_gridsize3_width;
                $featured_image_height = $setupsizelimitconf_general_gridsize3_height;
				break;
			case 'grid4':
				$pf_grid_size = 4;
				$pfgrid_output = 'pf4col';
				$pfgridcol_output = '';
				$featured_image_width = $setupsizelimitconf_general_gridsize4_width;
                $featured_image_height = $setupsizelimitconf_general_gridsize4_height;
				break;
			default:
				$pf_grid_size = 4;
				$pfgrid_output = 'pf4col';
				$pfgridcol_output = '';
				$featured_image_width = $setupsizelimitconf_general_gridsize1_width;
                $featured_image_height = $setupsizelimitconf_general_gridsize1_height;
				break;
		}
		


		$loop = new WP_Query( $args );
		$foundedposts = $loop->found_posts;
		/*
		print_r($loop->query).PHP_EOL;
		echo $loop->request.PHP_EOL;
		echo $loop->found_posts;
		*/
		$post_ids = wp_list_pluck($loop->posts,'ID');
		if ($setup3_pt14_check == 1) {
			$post_contidions = wp_get_object_terms($post_ids, 'pointfinderconditions', array("fields" => "all_with_object_id"));
		}
		$post_listingtypes = wp_get_object_terms($post_ids, 'pointfinderltypes', array("fields" => "all_with_object_id"));


		$pflang = $this->PF_current_language();
		$stp22_qwlinknew = absint($this->PFSAIssetControl('stp22_qwlinknew','','0'));
		$setup22_showmapnew = absint($this->PFSAIssetControl('setup22_showmapnew','','0'));
		$setup4_favnew = absint($this->PFSAIssetControl('setup4_favnew','','0'));
		$wpflistdata .= '
		    <div class="pfsearchresults '.$pfcontainershow.' pflistgridview pflistgridview-static">';

		        $wpflistdata .=
		        '<div class="'.$pfcontainerdiv.'-content pflistcommonview-content" style="padding:0"  id="'.$carousel_id.'">';//List Content begin
		        
		        
		            $wpflistdata .='
		                <div class="pfitemlists-content-elements '.$pfgrid_output.' owl-carousel owl-theme" id="'.$myrandno.'">';


					$wpflistdata_output = '';
					
					/* Variables */

						$setup22_searchresults_animation_image  = $this->PFSAIssetControl('setup22_searchresults_animation_image','','WhiteSquare');
						$setup22_searchresults_hover_image  = absint($this->PFSAIssetControl('setup22_searchresults_hover_image','','0'));
						$setup22_searchresults_hover_video  = absint($this->PFSAIssetControl('setup22_searchresults_hover_video','','0'));
						$setup22_searchresults_hide_address  = absint($this->PFSAIssetControl('setup22_searchresults_hide_address','','0'));
						
						$pfbuttonstyletext = 'pfHoverButtonStyle ';
						
						switch($setup22_searchresults_animation_image){
							case 'WhiteRounded':
								$pfbuttonstyletext .= 'pfHoverButtonWhite pfHoverButtonRounded';
								break;
							case 'BlackRounded':
								$pfbuttonstyletext .= 'pfHoverButtonBlack pfHoverButtonRounded';
								break;
							case 'WhiteSquare':
								$pfbuttonstyletext .= 'pfHoverButtonWhite pfHoverButtonSquare';
								break;
							case 'BlackSquare':
								$pfbuttonstyletext .= 'pfHoverButtonBlack pfHoverButtonSquare';
								break;
							
						} 
						$st22srloc = absint($this->PFSAIssetControl('st22srloc','',1));
						$stp22_qwlink = absint($this->PFSAIssetControl('stp22_qwlink','','1'));
						$st8_npsys = absint($this->PFASSIssetControl('st8_npsys','',0));
	                    $footerln = absint($this->PFSAIssetControl('footerln','','1'));
	                    $fusedfltype = absint($this->PFSAIssetControl('fusedfltype','','0'));

	                    $listing_pstyle_meta = '';
					    if ($st8_npsys == 1) {
						    $listing_pstyle_meta = get_option('pointfinderltypes_style_vars');
					    }

					    $linkpermission1 = absint($this->PFSAIssetControl('st22srlinklt','','1'));
					    $st22srstxtlt1 = absint($this->PFSAIssetControl('st22srstxtlt','','1'));
					    $tooltip1 = absint($this->PFSAIssetControl('st22srstxttt','','0'));
					    $defaulticonname1 = $this->PFSAIssetControl('st22ltypebti','','fab fa-slack-hash');
					    $iconpermission1 = absint($this->PFSAIssetControl('st22ltypebts','','1'));
	                    $iconbox1 = absint($this->PFSAIssetControl('st22ltypebtsb','','1'));
					    $charlimit1 = absint($this->PFSAIssetControl('st22ltypebtcl','','100'));

					    $st22srstxtlt2 = absint($this->PFSAIssetControl('st22srstxtloc','','0'));
					    $tooltip2 = absint($this->PFSAIssetControl('st22srstxtttl','','1'));
					    $defaulticonname2 = $this->PFSAIssetControl('st22locypebti','','fas fa-map-marker-alt');
	                    $iconbox2 = absint($this->PFSAIssetControl('st22locypebtsb','','1'));
					    $iconpermission2 = absint($this->PFSAIssetControl('st22locypebts','','1'));
					    $charlimit2 = $this->PFSAIssetControl('st22loctypebtcl','','100');
					    $linkpermission2 = absint($this->PFSAIssetControl('st22srlinkloc','','1'));

					    $st22locypebtibg = $this->PFSAIssetControl('st22locypebtibg','','#efefef');
					    $st22locypebtiic = $this->PFSAIssetControl('st22locypebtiic','','#494949');
					    $st22ltypebtibg = $this->PFSAIssetControl('st22ltypebtibg','','#efefef');
					    $st22ltypebtiic = $this->PFSAIssetControl('st22ltypebtiic','','#494949');

					    $st22ltypebt = absint($this->PFSAIssetControl('st22ltypebt','','1'));
					    $st22locypebt = absint($this->PFSAIssetControl('st22locypebt','','1'));

						$user_loggedin_check = is_user_logged_in();


						
						$pfboptx1 = $this->PFSAIssetControl('setup22_searchresults_hide_excerpt','1','0');
						$pfboptx2 = $this->PFSAIssetControl('setup22_searchresults_hide_excerpt','2','0');
						$pfboptx3 = $this->PFSAIssetControl('setup22_searchresults_hide_excerpt','3','0');
						$pfboptx4 = $this->PFSAIssetControl('setup22_searchresults_hide_excerpt','4','0');
						
						if($pfboptx1 != 1){$pfboptx1_text = 'style="display:none"';}else{$pfboptx1_text = '';}
						if($pfboptx2 != 1){$pfboptx2_text = 'style="display:none"';}else{$pfboptx2_text = '';}
						if($pfboptx3 != 1){$pfboptx3_text = 'style="display:none"';}else{$pfboptx3_text = '';}
						if($pfboptx4 != 1){$pfboptx4_text = 'style="display:none"';}else{$pfboptx4_text = '';}
						
						switch($pfgrid_output){case 'pf1col':$pfboptx_text = $pfboptx1_text;break;case 'pf2col':$pfboptx_text = $pfboptx2_text;break;case 'pf3col':$pfboptx_text = $pfboptx3_text;break;case 'pf4col':$pfboptx_text = $pfboptx4_text;break;}		
						
						if (is_user_logged_in()) {
							$user_favorites_arr = get_user_meta( get_current_user_id(), 'user_favorites', true );
							if (!empty($user_favorites_arr)) {
								$user_favorites_arr = json_decode($user_favorites_arr,true);
							}else{
								$user_favorites_arr = array();
							}
						}						
						
						$setup16_featureditemribbon_hide = absint($this->PFSAIssetControl('setup16_featureditemribbon_hide','','1'));
						$setup4_membersettings_favorites = absint($this->PFSAIssetControl('setup4_membersettings_favorites','','1'));
	                    $setup4_favnew = absint($this->PFSAIssetControl('setup4_favnew','','1'));
						$setup22_searchresults_hide_re = absint($this->PFREVSIssetControl('setup22_searchresults_hide_re','','1'));
						
						$setup16_reviewstars_nrtext = absint($this->PFREVSIssetControl('setup16_reviewstars_nrtext','','0'));
						$setup22_searchresults_hide_lt  = absint($this->PFSAIssetControl('setup22_searchresults_hide_lt','','0'));

						$st22srlinknw = absint($this->PFSAIssetControl('st22srlinknw','','0'));
						$targetforitem = '';
						if ($st22srlinknw == 1) {
							$targetforitem = ' target="_blank"';
						}

					if($loop->post_count > 0){
				
						while ( $loop->have_posts() ) : $loop->the_post();
						
						$post_id = get_the_id();

						
						$ItemDetailArr = array();
						
						if ($pflang) {
							$pfitemid = $this->PFLangCategoryID_ld($post_id,$pflang,$setup3_pointposttype_pt1);
						}else{
							$pfitemid = $post_id;
						}

						
						$featured_image_stored = $this->pointfinder_featured_image_getresized($pfitemid,$general_crop2,$general_retinasupport,$featured_image_width,$featured_image_height);

						$ItemDetailArr['featured_image_org'] = $featured_image_stored['featured_image_org'];
						$ItemDetailArr['featured_image'] = ($featured_image_stored['featured_image'] == false)?$featured_image_stored['featured_image_org']:$featured_image_stored['featured_image'];
						$ItemDetailArr['if_title'] = get_the_title($pfitemid);
						$ItemDetailArr['if_excerpt'] = get_the_excerpt();
						$ItemDetailArr['if_link'] = get_permalink($pfitemid);;
						$ItemDetailArr['if_address'] = esc_html(get_post_meta( $pfitemid, 'webbupointfinder_items_address', true ));
						$ItemDetailArr['featured_video'] =  esc_url(get_post_meta( $pfitemid, 'webbupointfinder_item_video', true ));
						$ItemDetailArr['if_author'] = get_the_author_meta( 'ID');

						
						$featured_check_x = get_post_meta( $pfitemid, 'webbupointfinder_item_featuredmarker', true );

						$data_values = $pfstviewcor = '';

	                      
                         $data_values .= ' data-pid="'.$pfitemid.'"';
                         $pfstviewcor = get_post_meta($pfitemid, 'webbupointfinder_items_location', true);

                         if (!empty($pfstviewcor)) {
                           $pfstviewcor = explode(',', $pfstviewcor);

                           if (count($pfstviewcor) >= 2) {
                            if (!empty($pfstviewcor[0]) && !empty($pfstviewcor[1])) {
                              $ItemDetailArr['lat'] = $pfstviewcor[0];
                              $data_values .= ' data-lat="'.$pfstviewcor[0].'"';
                              $ItemDetailArr['lng'] = $pfstviewcor[1];
                              $data_values .= ' data-lng="'.$pfstviewcor[1].'"';
                            }else{
                              $pfstviewcor = '';
                            }
                            
                           }
                         }
                         
                         $pfitemicon = $this->pf_get_markerimage($pfitemid,1,1,$st8_npsys);
                         
                         if($this->PFControlEmptyArr($pfitemicon)){
                  
                            if ($pfitemicon['is_cat'] == 1) {
                              $listing_icon = $this->pf_get_default_cat_images($pflang,$pfitemicon['cat'],$st8_npsys);

                              $data_values .= ' data-icon="'.$listing_icon.'"';
                            }

                            if ($pfitemicon['is_image'] == 1) {
                              $data_values .= ' data-icon="'.$pfitemicon['content'].'"';
                            }
                            
                          }

                         $data_values .= ' data-title="'.$ItemDetailArr['if_title'].'"';
	                     
	                     $data_values .= ' data-aid="'.$ItemDetailArr['if_author'].'"';

	                     if (!empty($featured_check_x)) {
	                      	$data_values .= ' data-fea="1"';
	                      }else{
	                      	$data_values .= ' data-fea="0"';
	                      }

						$post_listing_typeval = '';
						foreach ($post_listingtypes as $post_listingtype) {
							if ($pfitemid == $post_listingtype->object_id) {
								$post_listing_typeval = $post_listingtype->term_id;
							}
						}

						$ltypeargs = array(
							'id' => $pfitemid,
							'taxonomy' => 'pointfinderltypes',
							'st8_npsys' => $st8_npsys,
							'listing_pstyle_meta' => $listing_pstyle_meta,
							'fusedfltype' => $fusedfltype,
							'postterms' => $post_listingtype,
							'linkpermission' => $linkpermission1,
							'st22srstxtlt' => $st22srstxtlt1,
							'tooltip' => $tooltip1,
							'defaulticonname' => $defaulticonname1,
							'iconpermission' => $iconpermission1,
							'charlimit' => $charlimit1,
							'st22ltypebtibg' => $st22ltypebtibg,
							'st22ltypebtiic' => $st22ltypebtiic,
							'iconbox' => $iconbox1
						);

						$output_data = $this->PFIF_DetailText_ld($pfitemid,$setup22_searchresults_hide_lt,$post_listing_typeval,$ltypeargs);
						if (is_array($output_data)) {
							if (!empty($output_data['ltypes'])) {
								$output_data_ltypes = $output_data['ltypes'];
							} else {
								$output_data_ltypes = '';
							}
							if (!empty($output_data['content'])) {
								$output_data_content = $output_data['content'];
							} else {
								$output_data_content = '';
							}
							if (!empty($output_data['priceval'])) {
								$output_data_priceval = $output_data['priceval'];
							} else {
								$output_data_priceval = '';
							}
						} else {
							$output_data_priceval = '';
							$output_data_content = '';
							$output_data_ltypes = '';
						}
						
						

						$listing_image = $this->pointfinder_srcset_images($st8_imagewh,$pfitemid,$ItemDetailArr['featured_image'],$general_crop2,$general_retinasupport,$featured_image_width,$featured_image_height);


						$fav_check = 'false';
						/*li*/$wpflistdata_output .= '
							<div class="'.$pfgridcol_output.' wpfitemlistdata">
								<div class="pflist-item pflist-item-inner clearfix"'.$pfitemboxbg.$data_values.'>
								
									<div class="pflist-imagecontainer pflist-subitem">
									';
									
									if($setup22_searchresults_hover_image == 1){
										$wpflistdata_output .= "<a class='pfitemlink' href='".$ItemDetailArr['if_link']."'".$targetforitem.">";
										if ($general_crop2 == 3) {
											$wpflistdata_output .= "<div class='pfuorgcontainer'>".$listing_image."</div>";
										}else{
											$wpflistdata_output .= $listing_image;
										}
										$wpflistdata_output .= "</a>";
										
									}else{
										if ($general_crop2 == 3) {
											$wpflistdata_output .= "<div class='pfuorgcontainer'>".$listing_image."</div>";
										}else{
											$wpflistdata_output .= $listing_image;
										}
										$wpflistdata_output .= "</a>";
										

										$wpflistdata_output .= '
										<div class="pfImageOverlayH hidden-xs"></div>
										';
										if($setup22_searchresults_hover_video != 1 && !empty($ItemDetailArr['featured_video'])){	
										$wpflistdata_output .= '
										<div class="pfButtons pfStyleV pfStyleVAni hidden-xs">';
										}else{
										$wpflistdata_output .= '
										<div class="pfButtons pfStyleV2 pfStyleVAni hidden-xs">';
										}
											$wpflistdata_output .= '
											<span class="'.$pfbuttonstyletext.' clearfix">
												<a class="pficon-imageclick" data-pf-link="'.$ItemDetailArr['featured_image_org'].'" data-pf-type="image" style="cursor:pointer">
													<i class="far fa-image"></i>
												</a>
											</span>';
											if($setup22_searchresults_hover_video != 1 && !empty($ItemDetailArr['featured_video'])){	
											$wpflistdata_output .= '
											<span class="'.$pfbuttonstyletext.'">
												<a class="pficon-videoclick" data-pf-link="'.$ItemDetailArr['featured_video'].'" data-pf-type="iframe" style="cursor:pointer">
													<i class="fas fa-video"></i>
												</a>
											</span>';
											}
											$wpflistdata_output .= '
											<span class="'.$pfbuttonstyletext.'">
												<a class="pfitemlink" href="'.$ItemDetailArr['if_link'].'">
													<i class="fas fa-link"></i>
												</a>
											</span>
										</div>';
									}

									if ($setup16_featureditemribbon_hide != 0) {
		                        		if (!empty($featured_check_x)) {
		                        			$wpflistdata_output .= '<div class="pfribbon-wrapper-featured"><div class="pfribbon-featured">'.esc_html__('FEATURED','pointfindercoreelements').'</div></div>';
		                        		}
			                        }

			                        
			                        /* Start: Conditions */
										$wpflistdata_output .= '<div class="pfconditionsandfavarea pfquicklinks">';
				                        if ($setup3_pt14_check == 1 && !empty($post_contidions)) {
		                        			
		                        			foreach ($post_contidions as $post_condition) {
		                        				if ($post_condition->object_id == $pfitemid) {
													if (isset($post_condition->term_id)) {																
				                        				$contidion_colors = $this->pf_get_condition_color($post_condition->term_id);

				                        				$condition_c = (isset($contidion_colors['cl']))? $contidion_colors['cl']:'#494949';
				                        				$condition_b = (isset($contidion_colors['bg']))? $contidion_colors['bg']:'#f7f7f7';

				                        				$wpflistdata_output .= '<div class="pfconditions-tag" style="color:'.$condition_c.';background-color:'.$condition_b.'">';
					                        			$wpflistdata_output .= '<a href="' . esc_url( get_term_link( $post_condition->term_id, 'pointfinderconditions' ) ) . '" style="color:'.$condition_c.';">'.$post_condition->name.'</a>';
					                        			$wpflistdata_output .= '</div>';
				                        			}
				                        		}
				                        	}
											

				                        }
					                /* End: Conditions */

									if ($stp22_qwlinknew == 1) {
									$wpflistdata_output .= '<a class="pfquickview pfquickviewlinktop" data-pfitemid="'.$pfitemid.'" title="'.esc_html__('Quick Preview','pointfindercoreelements').'">
										<i class="fas fa-search"></i>
									</a>';
									}



									/* Start: Favorites */
						                if ($setup4_favnew == 1) {
						                    $favoriteicon = 'fas fa-heart';
											$favtitle_text = esc_html__('Add to Favorites','pointfindercoreelements');
											if ($user_loggedin_check && count($user_favorites_arr)>0) {

												if (in_array($pfitemid, $user_favorites_arr)) {
													$fav_check = 'true';
													$favtitle_text = esc_html__('Remove from Favorites','pointfindercoreelements');
													$favoriteicon = 'fas fa-heart';
												}
											}

											$wpflistdata_output .= '
											<a class="pf-favorites-link favoriteslinktop" data-pf-num="'.$pfitemid.'" data-pf-active="'.$fav_check.'" data-pf-item="true" title="'.$favtitle_text.'">
												<i class="'.$favoriteicon.'"></i></a>
											';
						                }
						            /* End: Favorites */

						            $wpflistdata_output .= '</div>';
									
									if ($output_data_priceval != '' || ($review_system_statuscheck == 1 && $setup22_searchresults_hide_re == 0)) {
										$wpflistdata_output .= '<div class="pflisting-itemband">';
									
										$wpflistdata_output .= '<div class="pflist-pricecontainer">';
										/* Start: Review Stars */
				                        if ($review_system_statuscheck == 1 && $setup22_searchresults_hide_re == 0) {

			                        		$reviews = $this->pfcalculate_total_review($pfitemid);

			                        		if (!empty($reviews['totalresult'])) {
			                        			$wpflistdata_output .= '<div class="pflist-reviewstars">';
			                        			$rev_total_res = round($reviews['totalresult']);
			                        			$wpflistdata_output .= '<div class="revpoint">';
			                        			$wpflistdata_output .= (strlen($reviews['totalresult']) > 1)?$reviews['totalresult']:$reviews['totalresult'].'.0';
			                        			$wpflistdata_output .= '</div>';
			                        			$wpflistdata_output .= '<div class="pfrevstars-wrapper-review">';
			                        			$wpflistdata_output .= ' <div class="pfrevstars-review">';
			                        				for ($ri=0; $ri < $rev_total_res; $ri++) { 
			                        					$wpflistdata_output .= '<i class="fas fa-star"></i> ';
			                        				}
			                        				for ($ki=0; $ki < (5-$rev_total_res); $ki++) { 
			                        					$wpflistdata_output .= '<i class="far fa-star"></i> ';
			                        				}

			                        			$wpflistdata_output .= '</div></div>';
			                        			$wpflistdata_output .= '</div>';
			                        		}else{
			                        			if($setup16_reviewstars_nrtext == 0){
			                        				$wpflistdata_output .= '<div class="pflist-reviewstars">';
				                        			$wpflistdata_output .= '<div class="pfrevstars-wrapper-review">';
				                        			$wpflistdata_output .= '<div class="pfrevstars-review pfrevstars-reviewbl"><i class="far fa-star"></i> <i class="far fa-star"></i> <i class="far fa-star"></i> <i class="far fa-star"></i> <i class="far fa-star"></i> </div></div>';
	                        						$wpflistdata_output .= '</div>';
			                        			}
			                        		}
				                        	
				                        }
					               		/* End: Review Stars */
										if ($output_data_priceval != '') {
											$wpflistdata_output .= $output_data_priceval;
										}else{
											$wpflistdata_output .= '<div class="pflistingitem-subelement pf-price" style="visibility: hidden;"></div>';
										}
										
										$wpflistdata_output .= '</div>';
								
										$wpflistdata_output .= '</div>';
									}

									if($pfgrid_output == 'pf1col'){
										$wpflistdata_output .= '</div><div class="pfrightcontent">';
									}else{
										$wpflistdata_output .='
										
									</div>
									';
									}

									
									
									$title_text = $ItemDetailArr['if_title'];
									$address_text = $ItemDetailArr['if_address'];
									$excerpt_text = $ItemDetailArr['if_excerpt'];
									
									$wpflistdata_output .= '
									<div class="pflist-detailcontainer pflist-subitem clearfix">
										<ul class="pflist-itemdetails">
											<li class="pflist-itemtitle pflineclamp-title"><a class="pfitemlink" href="'.$ItemDetailArr['if_link'].'">'.$title_text.'</a></li>
											';

											if($setup22_searchresults_hide_address == 0){
												if (!empty($address_text)) {
													$wpflistdata_output .= '<li class="pflist-address pflineclamp-address"><i class="fas fa-map-marker-alt"></i> '.$address_text.'</li>';
												}else{
													$wpflistdata_output .= '<li class="pflist-address pflineclamp-address"></li>';
												}
											}

											if ($st22srloc == 1 && $st22locypebt == 2) {
												$loctypeargs = array(
													'id' => $pfitemid,
													'taxonomy' => 'pointfinderlocations',
													'st8_npsys' => $st8_npsys,
													'listing_pstyle_meta' => '',
													'fusedfltype' => '',
													'postterms' => '',
													'linkpermission' => $linkpermission2,
													'st22srstxtlt' => $st22srstxtlt2,
													'tooltip' => $tooltip2,
													'defaulticonname' => $defaulticonname2,
													'iconpermission' => $iconpermission2,
													'charlimit' => $charlimit2,
													'st22locypebtibg' => $st22locypebtibg,
													'st22locypebtiic' => $st22locypebtiic,
													'iconbox' => $iconbox2
												);
												$location_val = $this->GetPFTermInfoX($loctypeargs);
												if (!empty($location_val)) {
													$wpflistdata_output .= '<li class="pflist-ltypemid pfmiddleltype">'.$location_val.'</li>';
												}
											}

											if (!empty($output_data_ltypes) && $st22ltypebt == 2) {
												$wpflistdata_output .= '<li class="pflist-ltypemid pfmiddleltype">'.$output_data_ltypes.'</li>';
											}

											$wpflistdata_output .= '
										</ul>
									</div>
									';
									if($pfboptx_text != 'style="display:none"' && $pfgrid != 'grid1'){
									$wpflistdata_output .= '
										<div class="pflist-excerpt pflist-subitem pflineclamp-excerpt" '.$pfboptx_text.'>'.$excerpt_text.'</div>
									';
									}
									if ((!empty($output_data_content) ) && $pfgrid != 'grid1') {
										$wpflistdata_output .= '<div class="pflist-subdetailcontainer pflist-subitem"><div class="pflist-customfields">'.$output_data_content.'</div></div>';
									}

									/* Show on map text for search results and search page */
									if ($footerln == 1) {
										$wpflistdata_output .= '<div class="pflist-subdetailcontainer pflist-subitem pfshowmapmain clearfix">';
										if ( $st22srloc == 1 && $st22locypebt == 1 ) {
											$loctypeargs  = array(
												'id'                  => $pfitemid,
												'taxonomy'            => 'pointfinderlocations',
												'st8_npsys'           => $st8_npsys,
												'listing_pstyle_meta' => '',
												'fusedfltype'         => '',
												'postterms'           => '',
												'linkpermission'      => $linkpermission2,
												'st22srstxtlt'        => $st22srstxtlt2,
												'tooltip'             => $tooltip2,
												'defaulticonname'     => $defaulticonname2,
												'iconpermission'      => $iconpermission2,
												'charlimit'           => $charlimit2,
												'st22locypebtibg'     => $st22locypebtibg,
												'st22locypebtiic'     => $st22locypebtiic,
												'iconbox'             => $iconbox2
											);
											$location_val = $this->GetPFTermInfoX( $loctypeargs );

											if ( ! empty( $location_val ) ) {
												$wpflistdata_output .= $location_val;
											}
										}

										if ( ! empty( $output_data_ltypes ) && $st22ltypebt == 1 ) {
											$wpflistdata_output .= $output_data_ltypes;
										}

										$wpflistdata_output .= '<div class="pfquicklinks">';
										if ( $stp22_qwlink == 1 ) {
											$wpflistdata_output .= '<a data-pfitemid="' . $pfitemid . '" class="pfquickview" title="' . esc_html__( 'Quick Preview', 'pointfindercoreelements' ) . '">
													<i class="fas fa-search"></i>
												</a>';
										}


										/* Start: Favorites */
										if ( $setup4_membersettings_favorites == 1 || $setup4_favnew == 1) {
											$favoriteicon  = 'fas fa-heart';
											$favtitle_text = esc_html__( 'Add to Favorites', 'pointfindercoreelements' );
											if ( $user_loggedin_check && count( $user_favorites_arr ) > 0 ) {

												if ( in_array( $pfitemid, $user_favorites_arr ) ) {
													$fav_check     = 'true';
													$favtitle_text = esc_html__( 'Remove from Favorites', 'pointfindercoreelements' );
													$favoriteicon  = 'fas fa-heart';
												}
											}

											$wpflistdata_output .= '
													<a class="pf-favorites-link" data-pf-num="' . $pfitemid . '" data-pf-active="' . $fav_check . '" data-pf-item="true" title="' . $favtitle_text . '">
														<i class="' . $favoriteicon . '"></i></a>
													';
										}
										/* End: Favorites */
										$wpflistdata_output .= '</div>';
										$wpflistdata_output .= '</div>';
									}
								/* End: Detail Texts */
									
									$wpflistdata_output .= '
									</div>
							
								
							</div>
						';/*li*/
							
						
							
							
						endwhile;
						
						$wpflistdata .= $wpflistdata_output;               
			            $wpflistdata .= '</div>';/*ul*/
					}
		           

					wp_reset_postdata();

					$wpflistdata .= '</div>';//List Content End
					$wpflistdata .= "</div></div> ";//Form End . List Data End
			
					if ($foundedposts > 0) {
						$content_script = '
						(function($) {
							"use strict"
							$(function() {
								$("#'.$myrandno.'").owlCarousel({
									rtl:(pointfinderlcsc.rtl == "true")?true:false,
									lazyLoad:false,
									items : '.$pf_grid_size.',';
									 if($hide_prev_next_buttons !== "yes"){ 
									 	$content_script .= 'nav : true,';
									 }else{
									 	$content_script .= "nav : false,";
									 }
									 if($hide_pagination_control !== "yes"){
									 	$content_script .= 'dots : true,';
									 }else{
									 	$content_script .= "dots : false,";
									 }
									 if($autoplay == "yes"){
									 	$content_script .= 'autoplay : true,';
									 }else{
									 	$content_script .= 'autoplay : false,';
									 }
									$content_script .='
									autoplayHoverPause : true,
									autoplayTimeout:'.$speed.',
									margin: '.$itemspacebetween.',
									navText:["<i class=\"fas fa-chevron-left\"></i>","<i class=\"fas fa-chevron-right\"></i>"],
									autoHeight : false,
									responsiveClass:true,
									loop:true,
									responsive : {
							            0 : {
							                items : 1
							            },
							            479 : {
							                items : 1
							            },
							            979 : {
							                items : 4
							            },
							            768 : {
							                items : 2
							            },
							            980 : {
							                items : '.$pf_grid_size.'
							            },
							            1199 : {
							                items : '.$pf_grid_size.'
							            }
							        }
								});
							});

						
						})(jQuery);';
						wp_add_inline_script('pftheme-customjs',$content_script,'after');
					}
					


			if ($foundedposts > 0) {
				return $wpflistdata;
			}else{
				return '';
			}

    }

}
new PointFinderListingCarouselShortcode();
