(function($) {
	"use strict";
	$.PFNewMapSys = {
	    init: function(handler){
	    	$.pointfindernewmapsys = $.pointfinderbuildmap(handler);
	    	
	    },
	    addMarkers: function(){
	    	if (!$('body').hasClass('pftoppagemapviewdef')) {
		    	$.pointfindernewmapclearlayers();

		    	if ($('.pfitemlists-content-elements').length > 0 && $('.pfsearchresults').data('foundposts') > 0) {
		    		
		    		var layerGroup = L.layerGroup();
		    		$.pointfindermarkerel = [];
		    		var i = 0;
		    		var marker,iconanchor;
		    		if ($('#wpf-map').length > 0) {
	    				var mapname = 'wpf-map';
	    			} else {
	    				var mapname = 'pointfinder-category-map';
	    			}
		    		$.each($('.pfitemlists-content-elements .pflist-item'), function(index, val) {
		    			if(typeof val.dataset.icon != 'undefined'){
							if (val.dataset.icon.indexOf("3-small") != -1) {
								iconanchor = [0, -11];
							}else{
								iconanchor = [0, -31];
							}
						}else{
							iconanchor = [0, -31];
						}

		    			if ((val.dataset.lat != undefined) && (val.dataset.lng != undefined)) {
		    				marker = $.pointfindermarkerel[index] = $.pointfinderbuildmarker(mapname,$.pointfindernewmapsys,val.dataset.lat,val.dataset.lng,val.dataset.pid,val.dataset.title,val.dataset.icon,iconanchor);
				      		layerGroup.addLayer(marker);
				      		i++;
				      	}else{
				      		$(this).find('.pfshowmaplink').hide();
				      	}
		    		});
		    		
		    		if ( i > 1 ) {
		    			$.pointfinderbuildcluster(mapname,$.pointfindernewmapsys,layerGroup);
					}else if( i == 1){
						marker.addTo($.pointfindernewmapsys);
						$.pointfindernewmapsys.flyTo(marker.getLatLng(),16,{animate:false});
					}else if( i == 0){
						if (!$('body').hasClass('pfhalfpagemapview') || !$('body').hasClass('pftoppagemapview')) {
							$.pointfindernewmapsys.remove();
							$('#'+mapname+'').remove();
						}
					}
		    	}
		    }	

		},
		geolocateMarkers: function(latlng){
	    	$.pointfindernewmapclearlayers();

	    	if ($('.pfitemlists-content-elements').length > 0 ) {
	    		
	    		var layerGroup = L.layerGroup();

	    		var i = 0;
	    		var marker;
	    		var contains = false;
	    		if ($('#wpf-map').length > 0) {
    				var mapname = 'wpf-map';
    			} else {
    				var mapname = 'pointfinder-category-map';
    			}
    			var customdistance = $('#'+mapname+'').data("gldistance") * 1000;

    			var circleCheck = L.circle(latlng,{
		 			radius: customdistance
	            }).addTo($.pointfindernewmapsys);

	    		var cicleCheckBounds = circleCheck.getBounds();
	    		circleCheck.remove();

	    		$.each($('.pfitemlists-content-elements .pflist-item'), function(index, val) {
	    			
	    			if ((val.dataset.lat != undefined) && (val.dataset.lng != undefined)) {

	    				if (cicleCheckBounds.contains(L.latLng(parseFloat(val.dataset.lat),parseFloat(val.dataset.lng)))) {
	    					contains = true;
	    				} else {
	    					contains = false;
	    				}
	    				if (contains) {
				      		layerGroup.addLayer($.pointfindermarkerel[index]);
				      		i++;
			      		}
			      	}else{
			      		$(this).find('.pfshowmaplink').hide();
			      	}
	    		});
	    		
	    		if ( i >= 1 ) {
	    			$.pointfinderbuildcluster(mapname,$.pointfindernewmapsys,layerGroup);
				}else if( i == 0){
					
					if (!$('body').hasClass('pfhalfpagemapview') || !$('body').hasClass('pftoppagemapview')) {
						$.pointfindernewmapsys.remove();
						$(mapname).remove();
					}
				}
	    	}

		}

 	}


 	$.pfgeolocatecontrolbutton = function(latlng){
		$.PFNewMapSys.geolocateMarkers(latlng);
		$.pointfindernewmapsys.stopLocate();
	}

 	$.pfloadlistings = function(ne,sw,ne2,sw2,saction,sdata,wherex,fromx){

 		if (typeof fromx == 'undefined') {
 			fromx ='halfmap';
 		}

		var kxdata = [{name:'post_tags',value:''+$('.pfsearchresults-container').data("tag")+''},{name:'pointfinderltypes',value:''+$('.pfsearchresults-container').data("lt")+''},{name:'pointfinderlocations',value:''+$('.pfsearchresults-container').data("lc")+''},{name:'pointfinderconditions',value:''+$('.pfsearchresults-container').data("co")+''},{name:'pointfinderitypes',value:''+$('.pfsearchresults-container').data("it")+''},{name:'pointfinderfeatures',value:''+$('.pfsearchresults-container').data("fe")+''}];

		if ($('.pfsearchresults-container').data("sdata") != '') {
			if(sdata == '' || typeof sdata == 'undefined' || sdata == null ){
				sdata = $('.pfsearchresults-container').data("sdata");
				if (typeof saction == 'undefined') {
					if (fromx=='halfmap') {
						fromx = 'halfmapx';
					}
					if (fromx=='topmap') {
						fromx = 'topmapx';
					}
				}
				saction = 'search';
			}
	  	}


	  	if (typeof sdata != 'undefined') {

			if (typeof sdata[0] != 'undefined') {
				
				if (sdata[0].name == 'wherefr' && sdata[0].value == 'halfmapsearch') {
					if (fromx=='halfmap') {
						fromx = 'halfmapx';
					}
					if (fromx=='topmap') {
						fromx = 'topmapx';
					}
					saction = 'search';
				}
			}
			
	  	}

	  	$.pfgetpagelistdata({saction : saction,sdata : sdata,dtx :kxdata,ne : ne,sw : sw,ne2 : ne2,sw2 : sw2,from : fromx});

	  	setTimeout(function(){$.PFNewMapSys.addMarkers();},10);
	};

	$.pfmapafterworks = function(){
		if ($('#pointfinder_google_search_coord').length > 0 && $('#pointfinder_google_search_coord').val().length == 0){
			$('#pointfinder_google_search_coord').val($('.pfsearchresults-container').data("coordval"));
		}

		var fltf = $('.pfsearchresults-container').data("fltf");
		var csauto = $('.pfsearchresults-container').data("csauto");
		var ltm = $('.pfsearchresults-container').data("ltm");
		var fltf_get = $('.pfsearchresults-container').data("fltfget");
		var fltf_getsel = $('.pfsearchresults-container').data("fltfgetsel");

		if (csauto != '' && fltf_get == '') {
			if (!$.pf_tablet_check()){
				if ($("#"+fltf+"" )) {
					if (ltm != csauto) {
						if (theme_scriptspf.mobiledropdowns != '1') {
							$("#"+fltf+"_sel" ).select2("val",ltm);
						}else{
							$("#"+fltf+" option[value=\""+ltm+"\"]").attr("selected","selected");
						}
					}else{
						if (theme_scriptspf.mobiledropdowns != '1') {
							$("#"+fltf+"_sel" ).select2("val",csauto);
						}else{
							$("#"+fltf+" option[value=\""+csauto+"\"]").attr("selected","selected");
						}
					}
				}
			}else{
				if (ltm != csauto) {
					$("#"+fltf+"_sel").val(""+ltm+"").trigger('change');
				}else{
					$("#"+fltf+"_sel").val(""+csauto+"").trigger('change');
				}
			}
		} else {
			if (!$.pf_tablet_check()){
				if ($("#"+fltf+"_sel" ).length > 0) {					
					if (theme_scriptspf.mobiledropdowns != '1') {
						
						if($('.pfhalfmapdraggable').length > 0){
							if (fltf_getsel != '') {
								$("#"+fltf+"_sel" ).val(""+fltf_getsel+"").trigger('change');
							}else{
								$("#"+fltf+"_sel" ).val(""+fltf_get+"").trigger('change');
							}
						}else{
							if (fltf_getsel != '') {
								$("#"+fltf+"_sel" ).select2("val",""+fltf_getsel+"");
							}else{
								$("#"+fltf+"_sel" ).select2("val",""+fltf_get+"");
							}
						}
					}else{
						$("#"+fltf+" option[value=\""+fltf_get+"\"]").attr("selected","selected");
					}
				}
			}else{
				if ($("#"+fltf+"_sel" ).length > 0) {	
					if (fltf_getsel != '') {
						$("#"+fltf+"_sel" ).val(""+fltf_getsel+"").trigger('change');
					}else{
						$("#"+fltf+"_sel" ).val(""+fltf_get+"").trigger('change');
					}
				}
				
			}
		}

	}

	$.pfremovebyresults = function(){        	
		if($('.pfsearchgridview').length > 0){
			$('.pfsearchgridview').remove();
		};
		$('.pfsearchgridview').hide('fade',{ direction: "up" },300)
		
		$.pfscrolltotop();
	};

  	$(function(){

  		if ($('body').hasClass('pfhalfpagemapview')) {
  			
			$.pfloadlistings();
			if ($('#wpf-map').length > 0) {
				$.PFNewMapSys.init('wpf-map');
			}

			if ($('body').hasClass('tax-pointfinderlocations')) {
				var floct = $('.pfsearchresults-container').data("floct");
				var floctdata = $('.pfsearchresults-container').data("lc");
				var csauto = $('.pfsearchresults-container').data("csauto");

				if (csauto != '' && floct.length > 0 && floctdata != '' && $("#"+floct+"").length > 0) {
					if (!$.pf_tablet_check()){
						$("#"+floct+" option[value=\""+csauto+"\"]").attr("selected","selected");
					}else{
						setTimeout(function(){$("#"+floct+"" ).select2("val",csauto);},500);
					}
				}
			}
		}else if ($('body').hasClass('pftoppagemapview')) {
  			
			$.pfloadlistings('','','','','','','','topmap');
			if ($('#wpf-map').length > 0) {
				$.PFNewMapSys.init('wpf-map');
			}

			if ($('body').hasClass('tax-pointfinderlocations')) {
				var floct = $('.pfsearchresults-container').data("floct");
				var floctdata = $('.pfsearchresults-container').data("lc");
				var csauto = $('.pfsearchresults-container').data("csauto");

				if (csauto != '' && floct.length > 0 && floctdata != '' && $("#"+floct+"").length > 0) {
					
					if (!$.pf_tablet_check()){
						$("#"+floct+" option[value=\""+csauto+"\"]").attr("selected","selected");
					}else{
						setTimeout(function(){$("#"+floct+"" ).select2("val",csauto);},500);
					}
				}
			}
		}else if ($('body').hasClass('pftoppagemapviewdef')) {
  			
			$.pfloadlistings('','','','','','','','topmap');
			

			if ($('body').hasClass('tax-pointfinderlocations')) {
				var floct = $('.pfsearchresults-container').data("floct");
				var floctdata = $('.pfsearchresults-container').data("lc");
				var csauto = $('.pfsearchresults-container').data("csauto");

				if (csauto != '' && floct.length > 0 && floctdata != '' && $("#"+floct+"").length > 0) {
					
					if (!$.pf_tablet_check()){
						$("#"+floct+" option[value=\""+csauto+"\"]").attr("selected","selected");
					}else{
						setTimeout(function(){$("#"+floct+"" ).select2("val",csauto);},500);
					}
				}
			}
		}else if ( $('#pfwidgetmap').length > 0 && $('#pointfinder-category-map').length == 0 ) {

			$.PFNewMapSys.init('pfwidgetmap');

		}else if($('#pointfinder-category-map').length > 0) {
			$.PFNewMapSys.init('pointfinder-category-map');
			setTimeout(function(){$.PFNewMapSys.addMarkers();},100);
		}

		$('body').on('click', '.pfshowmaplink', function(e){

			var marker = $.pointfindernewmapsys.getMarkerById($(this).data('pfitemid'),"categorymapmarkers");
			if(marker != null){
				$.pointfindernewmapsys.flyTo(marker.getLatLng(),14,{animate:false});
				marker.openPopup();
				if (!$('body').hasClass('pfhalfpagemapview')) {
					$(window).scrollTop(0);
				}
			}
			
			return false;
		});

		$('#pf-resetfilters-button').on('click', function(event) {
			event.preventDefault();
			$.pfremovebyresults();
			
			var fltf = $('.pfsearchresults-container').data("fltf");
			var floct = $('.pfsearchresults-container').data("floct");
			var fltfdata = $('.pfsearchresults-container').data("lt");
			var floctdata = $('.pfsearchresults-container').data("lc");
			var csauto = $('.pfsearchresults-container').data("csauto");
			
			$('#pfsearchsubvalues').html('');
			$('#pointfinder-search-form').find(':input').not(':button, :submit, :reset, :hidden, :checkbox, :radio').val('')


			if (typeof $('#pointfinder_google_search_coord').attr("value") != 'undefined' || $('#pointfinder_google_search_coord').attr("value") != '') {
				$('#pointfinder_google_search_coord').attr("value",'');
				$('input[name=ne]').attr("value",'');$('input[name=ne2]').attr("value",'');$('input[name=sw]').attr("value",'');$('input[name=sw2]').attr("value",'');
			}


			/* If location */
			if (csauto != '' && floct.length > 0 && floctdata != '' && $("#"+floct+"").length > 0) {
				if (!$.pf_tablet_check()){
					if (theme_scriptspf.mobiledropdowns != '1') {
						setTimeout(function(){$("#"+floct+"" ).select2("val",csauto);},500);
					}else{
						$("#"+floct+" option[value=\""+csauto+"\"]").attr("selected","selected");
					}
				}else{
					$("#"+floct+"" ).select2("val",csauto);
				}
			}


			/* If listing type */
			if (csauto != '' && fltf.length > 0 && fltfdata != '') {
				if (!$.pf_tablet_check()){
					if (theme_scriptspf.mobiledropdowns != '1') {
						setTimeout(function(){$("#"+fltf+"" ).select2("val",csauto).trigger('change');},500);
					}else{
						$("#"+fltf+" option[value=\""+csauto+"\"]").attr("selected","selected");
					}
				}else{
					$("#"+fltf+"_sel" ).select2("val",csauto);
				}
			}else{
				if ($.pf_tablet_check()){

					if ($("#"+fltf+"_sel").length > 0) {
						$("#"+fltf+"" ).val("");
						$('.pfsearchresults-container').attr("data-fltfget","");
						$('.pfsearchresults-container').attr("data-fltfgetsel","");
						$('.pfsearchresults-container').data("fltfget","");
						$('.pfsearchresults-container').data("fltfgetsel","");
						$("#"+fltf+"_sel" ).val(null).trigger('change');
					}else if ($("#"+fltf+"_sel").length == 0 && $("#"+fltf+"").length > 0) {
						if (!$.pf_tablet_check()){
							$("#"+fltf+"").val("").trigger('change');
						}else{
							$("#"+fltf+"").val(null).trigger('change');
						}
						
					}
				}
				
			}

         
			var kxdata = [{name:'post_tags',value:''+$('.pfsearchresults-container').data("tag")+''},{name:'pointfinderltypes',value:''+$('.pfsearchresults-container').data("lt")+''},{name:'pointfinderlocations',value:''+$('.pfsearchresults-container').data("lc")+''},{name:'pointfinderconditions',value:''+$('.pfsearchresults-container').data("co")+''},{name:'pointfinderitypes',value:''+$('.pfsearchresults-container').data("it")+''},{name:'pointfinderfeatures',value:''+$('.pfsearchresults-container').data("fe")+''}];
			
			if ($('.pfsearchresults-container').length > 0) {
				if ($('.pfsearchresults-container').data('sdata') != '') {
					$('.pfsearchresults-container').data('sdata','');
					$('.pfsearchresults-container').attr('data-sdata','');
					$('.pfsearchresults-container').data('fltfget','');
					$('.pfsearchresults-container').attr('data-fltfget','');
				}
			}

			

			if ($('body').hasClass('pftoppagemapview') || $('body').hasClass('pftoppagemapviewdef') || $('body').hasClass('pfhalfpagemapview')) {

				window.history.pushState(null, '', '?s=&serialized=1&action=pfs');
				$.pfgetpagelistdata({saction : '',sdata : '',dtx :kxdata,ne : '',sw : '',ne2 : '',sw2 : '',from : 'topmap'});
			}else{
				window.history.pushState(null, null, window.location.pathname);
				$.pfgetpagelistdata({saction : '',sdata : '',dtx :kxdata,ne : '',sw : '',ne2 : '',sw2 : '',from : 'halfmap'});
			}
	  		
	  		setTimeout(function(){$.PFNewMapSys.addMarkers();},10);
			
		});


		$('#pf-search-button-halfmap').on('click',function(){
			
			var form = $('#pointfinder-search-form');
			if (form.valid()) {

				if(typeof form.data("changed") != 'undefined' && form.data("changed") === true){
					if ($('.pfsearchresults-container').data('sdata') != '') {
						$('.pfsearchresults-container').data('sdata','');
						$('.pfsearchresults-container').attr('data-sdata','');
						$('.pfsearchresults-container').data('fltfget','');
						$('.pfsearchresults-container').attr('data-fltfget','');
					}
				}

				$.pfremovebyresults();

				form.find("div:hidden[id$='_main']").each(function(){
					$(this).find('input[type=hidden]').not("#pointfinder_radius_search-view2").not("#pointfinder_radius_search-view").not("#pointfinder_areatype").val(""); 
					if (typeof $.pfsliderdefaults == 'undefined') {
						$.pfsliderdefaults = {};$.pfsliderdefaults.fields = Array();
					}
					$(this).find('input[type=text]').val($.pfsliderdefaults.fields[$(this).attr('id')]);
					$(this).find('.slider-wrapper .ui-slider-range').not("#pointfinder_radius_search .ui-slider-range").css('width','0%');
					$(this).find('.slider-wrapper a:nth-child(2)').css('left','0%');
					$(this).find('.slider-wrapper a:nth-child(3)').css('left','100%');

					if ($('.pfsearchresults-container').length > 0) {
						if ($('.pfsearchresults-container').data('sdata') != '') {
							$('.pfsearchresults-container').data('sdata','');
							$('.pfsearchresults-container').attr('data-sdata','');
							$('.pfsearchresults-container').data('fltfget','');
							$('.pfsearchresults-container').attr('data-fltfget','');
						}
					}
				});
				$.pfsearchformvars = {};
				$.pfsearchformvars.action = 'search';
				$.pfsearchformvars.vars = form.serializeArray();
				
				
				if ($('#pointfinder_google_search_coord').length > 0 && $('#pointfinder_google_search_coord').val().length !== 0) {
					 	
					 	if (typeof $('.pfsearchresults-container').attr("data-sw2") == 'undefined') {
							$.pfloadlistings('','','','',$.pfsearchformvars.action,$.pfsearchformvars.vars);
					 	}else{
					 		$.pfloadlistings('','','','',$.pfsearchformvars.action,$.pfsearchformvars.vars);
					 	}

						if (!$.pf_mobile_check()) {
							if($('#pfsearch-draggable').hasClass('pfshowmobile') == true){
								$('#pf-primary-search-button i').switchClass('fas fa-cog', 'pfadmicon-glyph-627', 'fast',"easeInOutQuad");
								$('#pfsearch-draggable').removeClass('pfshowmobile');
								$('#pfsearch-draggable').hide("fade",{ direction: "up" }, "fast", function(){});	
							}
						}
				}else{
					$.pfloadlistings('','','','',$.pfsearchformvars.action,$.pfsearchformvars.vars);
				}

				if (!$.pf_tablet2_check()) {
					var direction = $('.psearchdraggable').attr("data-direction");
					if ($('.psearchdraggable').css(direction) == '0px') {
						$('#pf-primary-search-button').trigger('click');
					}
				}
			}

			return false;
		});	

  	});

})(jQuery);