(function( $ ) {
	'use strict';
	$.pfReviewwithAjax = function(vars){

		$.ajax({
			beforeSend: function(){
				$('#pftrwcontainer').pfLoadingOverlay({action:'show'});
			},
            type: 'POST',
            dataType: 'json',
            url: theme_scriptspf.ajaxurl,
            data: {
                'action': 'pfget_modalsystemhandler',
                'formtype': 'reviewform',
                'vars': vars,
                'security': theme_scriptspf.pfget_modalsystemhandler,
                'lang': theme_scriptspf.pfcurlang
            },
            success:function(data){
				var obj = [];
				$.each(data, function(index, element) {
					obj[index] = element;
				});

				// Review Form works ---------------------------------------------------
				var form = $('#pf-review-form');
				var pfreviewoverlay = $("#pftrwcontainer-overlay");

				if (typeof grecaptcha !== 'undefined') {
					var formid;

					if (typeof form.id != 'undefined') {
						formid = form.id;
					}else{
						formid = form[0].id;
					}
					$.reCAPTCHA_execute(formid);
				}

				pfreviewoverlay.on('click',function(){
					pfreviewoverlay.hide("slide",{direction : "up"},100);
					pfreviewoverlay.find('.pf-overlay-close').remove();
					pfreviewoverlay.find('.pfrevoverlaytext').remove();
					if(obj.process == true){

						form.find("textarea").val("");
						form.find(':input').removeAttr('checked');
					}
				});
				if(obj.process == true){
					pfreviewoverlay.append("<div class='pf-overlay-close'><i class='fas fa-times'></i></div><div class='pfrevoverlaytext pfoverlayapprove'><i class='fas fa-check-circle'></i><span>"+obj.mes+"</span></div>");
					pfreviewoverlay.show("slide",{direction : "up"},100);
				}else{
					pfreviewoverlay.append("<div class='pf-overlay-close'><i class='fas fa-times'></i></div><div class='pfrevoverlaytext'><i class='fas fa-exclamation-triangle'></i><span>"+obj.mes+"</span></div>");
					pfreviewoverlay.show("slide",{direction : "up"},100);
				}

				$('.pf-overlay-close').on('click',function(){
					pfreviewoverlay.hide("slide",{direction : "up"},100);
					pfreviewoverlay.find('.pf-overlay-close').remove();
					pfreviewoverlay.find('.pfrevoverlaytext').remove();
					if(obj.process == true){

						form.find("textarea").val("");
						form.find(':input').removeAttr('checked');
					}
				});
				// Review Form works ---------------------------------------------------


            },
            error: function (request) {
                $("#pftrwcontainer-overlay").append("<span class='pfrevoverlaytext'>Error:"+request.responseText+"</span>");
            },
            complete: function(){
            	$('#pftrwcontainer').pfLoadingOverlay({action:'hide'});
            },
        });

	};

	$(function() {

		function pflistrevs(lid,page,orderby){

			$.ajax({
				beforeSend: function(){
					$('.pfreviews').pfLoadingOverlay({action:'show'});
				},
				type: 'POST',
				dataType: 'html',
				url: theme_scriptspf.ajaxurl,
				data: {
					'action': 'pfget_listreviews',
					'security': $('.pfreviews.golden-forms').data("nonce"),
					'lid': lid,
					'page': page,
					'orderby': orderby,
					'lang': theme_scriptspf.pfcurlang
				},
				success:function(data){

					$('.pfreviews.golden-forms').html(data);

					$('.pfreviewspaginate a').on('click',function(e){
						e.preventDefault();
						e.stopPropagation();

						var pg = $('.pfreviewspaginate').data('curpage');

						if (pg === '') {pg = 1;}

						if($(this).hasClass('prev')){
							pg--;
						}else if($(this).hasClass('next')){
							pg++;
						}else{
							pg = $(this).data("pn");
						}

						pflistrevs($('.pfreviews.golden-forms').data("lid"),pg,"newest");
					});

				},
				error: function (request) {
					console.log(request.responseText);
				},
				complete: function(){
					$('.pfreviews').pfLoadingOverlay({action:'hide'});
				},
			});
		}

		if($('.pfreviews.golden-forms').length > 0){
			pflistrevs($('.pfreviews.golden-forms').data("lid"),1,"newest");
		}




		/*Fix for sharebar*/
		$('body').on('click', '.pf-sharebar-icons li a', function(){return false;});
		$('body').on('click','.pf-report-link',function(){
			$.maindivfav = $(this);
			$.ajax({
	            type: 'POST',
	            dataType: 'json',
	            url: theme_scriptspf.ajaxurl,
	            data: {
	                'action': 'pfget_reportitem',
	                'item': $.maindivfav.attr('data-pf-num'),
	                'security': theme_scriptspf.pfget_reportitem
	            },
	            success:function(data){
					var obj = [];
					$.each(data, function(index, element) {
						obj[index] = element;
					});

					if (!$.isEmptyObject(obj)) {

						if (obj.user == 0 && obj.rs == "1") {
							$.pfOpenLogin('open','login');
						}else if(obj.user == 0 && obj.rs == "0"){
							$.pfOpenModal('open','reportform','','',obj.item);
						}else if(obj.user != 0 && obj.rs == "1"){
							$.pfOpenModal('open','reportform','','',obj.item);
						}else if(obj.user != 0 && obj.rs == "0"){
							$.pfOpenModal('open','reportform','','',obj.item);
						}

					}

	            }
	        });
		});

		$('body').on('click','#pfclaimitem',function(){
			$.maindivfav = $(this);
			$.ajax({
	            type: 'POST',
	            dataType: 'json',
	            url: theme_scriptspf.ajaxurl,
	            data: {
	                'action': 'pfget_claimitem',
	                'item': $.maindivfav.attr('data-pf-num'),
	                'security': theme_scriptspf.pfget_claimitem
	            },
	            success:function(data){
					var obj = [];
					$.each(data, function(index, element) {
						obj[index] = element;
					});

					if (!$.isEmptyObject(obj)) {

						if (obj.user == 0 && obj.rs == "1") {
							$.pfOpenLogin('open','login');
						}else if(obj.user == 0 && obj.rs == "0"){
							$.pfOpenModal('open','claimform','','',obj.item);
						}else if(obj.user != 0 && obj.rs == "1"){
							$.pfOpenModal('open','claimform','','',obj.item);
						}else if(obj.user != 0 && obj.rs == "0"){
							$.pfOpenModal('open','claimform','','',obj.item);
						}

					}

	            }
	        });
		});

		$('body').on('click', '.review-flag-link', function(){
			$.maindivfav = $(this);
			$.ajax({
	            type: 'POST',
	            dataType: 'json',
	            url: theme_scriptspf.ajaxurl,
	            data: {
	                'action': 'pfget_flagreview',
	                'item': $.maindivfav.attr('data-pf-revid'),
	                'security': theme_scriptspf.pfget_flagreview
	            },
	            success:function(data){
					var obj = [];
					$.each(data, function(index, element) {
						obj[index] = element;
					});

					if (!$.isEmptyObject(obj)){

						if (obj.user == 0 ) {
							$.pfOpenLogin('open','login');
						}else{
							$.pfOpenModal('open','flagreview','','',obj.item);

						}

					}

	            }
	        });
		});
		$('.pf-show-review-details').on( "mouseenter mouseleave",function(){

			if ($(this).find('.pf-itemrevtextdetails').is( ':visible' )) {
				$(this).find('.pf-itemrevtextdetails').hide();
				$(this).find('.pf-itemrevtextdetails').removeClass('animated bounceIn');
				$(this).find('.pf-itemrevtextdetails').addClass('animated bounceOut');
			}else{
				$(this).find('.pf-itemrevtextdetails').show();
				$(this).find('.pf-itemrevtextdetails').removeClass('animated bounceOut');
				$(this).find('.pf-itemrevtextdetails').addClass('animated bounceIn');
			}

		});
		$('#pf-ajax-enquiry-button').on('click touchstart',function(){
			var form = $('#pf-ajax-enquiry-form');

			var recaptchanum = form.find('#recaptcha_div_mod .g-recaptcha-field').data('rekey');
			if (recaptchanum) {
				recaptchanum = $.recaptchanum;
				form.find('#g-recaptcha-response').text(grecaptcha.getResponse(recaptchanum));
			}

			var pfsearchformerrors = form.find(".pfsearchformerrors");
			form.validate({
				  debug:false,
				  onfocus: false,
				  onfocusout: false,
				  onkeyup: false,
				  rules:{
				  	name:"required",
				  	email:{
				  		required:true,
				  		email:true
				  	},
				  	msg:"required",
				  	pftermsofuser:"required"
				  },
				  messages:{
				  	name:theme_scriptspf.pfnameerr,
				  	email: {
					    required: theme_scriptspf.pfemailerr,
						email: theme_scriptspf.pfemailerr2
				    },
				    msg:theme_scriptspf.pfmeserr,
				    pftermsofuser:theme_scriptspf.tnc_err2
				  },
				  validClass: "pfvalid",
				  errorClass: "pfnotvalid pfaddnotvalidicon",
				  errorElement: "li",
				  errorContainer: pfsearchformerrors,
				  errorLabelContainer: $("ul", pfsearchformerrors),
				  invalidHandler: function(event, validator) {
					var errors = validator.numberOfInvalids();
					if (errors) {
						pfsearchformerrors.show("slide",{direction : "up"},100);
						form.find(".pfsearch-err-button").on('click',function(){
							pfsearchformerrors.hide("slide",{direction : "up"},100);
							return false;
						});
					}else{
						pfsearchformerrors.hide("fade",300);
					}
				  }
			});



			if(form.valid()){
				$('#pf-ajax-enquiry-button').attr('disabled',true);
				$.pfModalwithAjax(form.serialize(),'enquiryform');
			}
			return false;
		});
		$('.comment-reply-login').on('click',function(){$.pfOpenLogin('open','login');return false;});
		$(".pftermshortc3").magnificPopup({
			type: "ajax",
			overflowY: "scroll"
		});
		$('body').on('click', '.ui-tabs label', function() {
			$.smoothScroll({scrollTarget: $(this),offset: -110});
		});

		var $owl1 = $("#pfitemdetail-slider");

	  
	    var autoplay_status = $owl1.data("autoplay");
      	var autoheight_status = $owl1.data("autoheight");
      	var tstyle = $("#pfitemdetail-slider").data("tstyle");

      	var animatein = ''; var animateout = '';
      	var tmode = "gallery";
      	
      	if (tstyle == 'fade') {
      		animatein = 'tns-fadeIn'; animateout = 'tns-fadeOut';
      	}else if (tstyle == 'zoom') {
      		animatein = 'zoomIn'; animateout = 'tns-fadeOut';
      	}else if (tstyle == 'none') {
      		tmode = "carousel";
      	}
    
      	if ($('#pf-customize-controls').length > 0) {
      		var slider = tns({
				"container": "#pfitemdetail-slider",
				"items": 1,
				"mode": tmode,
				"textDirection":(pointfinderlcsc.rtl == 'true')?'rtl':'ltr',
				"controlsContainer": "#pf-customize-controls",
				"navContainer": "#pfitemdetail-slider-sub",
				"navAsThumbnails": true,
				"autoplay": (autoplay_status == 1)?true:false,
				"autoplayTimeout": parseInt($("#pfitemdetail-slider").data("timer")),
				"autoplayHoverPause": true,
				"swipeAngle": false,
				"speed":400,
				"animateIn": animatein,
 				"animateOut": animateout,
			    "loop": true,
			    "autoHeight":(autoheight_status == 1)?true:false,
			    "lazyLoad": true,
			    "rewind": false,
			    "gutter":0,
			    "edgePadding":0
		  	});
      	}

      	if ($('#pfitemdetail-slider-sub').length > 0) {
	      	var slider2 = tns({
				"container": "#pfitemdetail-slider-sub",
				"items": 7,
				"textDirection":(pointfinderlcsc.rtl == 'true')?'rtl':'ltr',
				"controlsContainer": "#pf-customize-controls-sub",
				"navContainer": "#pfitemdetail-slider-sub",
				"swipeAngle": false,
				"speed": 400,
			    "loop": false,
			    "autoHeight":(autoheight_status == 1)?true:false,
			    "lazyLoad": true,
			    "rewind": false,
			    "gutter":10,
			    "edgePadding":0,
			    "responsive": {
			     	0 : {
		                items : 1
		            },
		            479 : {
		                items : 3
		            },
		            979 : {
		                items : 4
		            },
		            638 : {
		                items : 5
		            },
		            768 : {
		                items : 6
		            },
		            1200 : {
		                items : 7
		            }
			  	},
			  	"onInit": function(){
			  		if ($('#pfitemdetail-slider-sub').length > 0 && slider2.isOn == false && $.pf_tablet2_check()) {
			  			$("#pfitemdetail-slider-sub-mw").css('height', 'auto');
			  			$("#pfitemdetail-slider-sub").css('display', 'block');
			      	}
			  	}
			  });
      	}
      	if ($('#pfitemdetail-slider').length > 0) {
	      	$("#pfitemdetail-slider").magnificPopup({
	          delegate: "a",
	          type: "image",
	          gallery:{
	          enabled:true,
	          navigateByImgClick: true,
	          preload: [0,2],
	          arrowMarkup: "<button title=\"%title%\" type=\"button\" class=\"mfp-arrow mfp-arrow-%dir%\"></button>",
	          tPrev: ""+$("#pfitemdetail-slider").data("mes1")+"",
	          tNext: ""+$("#pfitemdetail-slider").data("mes2")+"",
	          tCounter: "<span class=\"mfp-counter\">%curr% / %total%</span>"
	          }
		    });
        }
		
		
		if ($('#pfsearch-filter').length > 0) {
			$('#pfsearch-filter').dropdown();
		}

	  	if ($("#pf-itempage-video").length > 0) {
	  		$("#pf-itempage-video").fitVids();
	  	}

	  	if ($(".pftabcontainer").length > 0 ) {
		  	$.ajax({
		  		url: theme_scriptspf.ajaxurl,
		  		type: 'POST',
		  		dataType: 'json',
		  		data: {l: $(".pftabcontainer").attr('data-lid'),security:theme_scriptspf.pfget_itemcount,action:'pfget_itemcount'},
		  	})
		  	.done(function(data) {});
	  	}

  	});

})( jQuery );
